﻿----------------------------------------------
--											--
-- Achchazus Raidplaner V1.38				--
-- 											--
-- from Renegade@Lucifron					--	
--											--
-- Special thanks to :						--
-- Messerbiene@Lucifron						--
-- Mayron @ https://discord.gg/fGNQStG		--
-- especially Shinon! 						--
--											--
----------------------------------------------

local addonName, addon = ...

local eventArgs = {...}

function out(text)
 DEFAULT_CHAT_FRAME:AddMessage(text)
 UIErrorsFrame:AddMessage(text, 1.0, 1.0, 0, 1, 10) 
end

AchchazusRaidplanerDB = {}
AchchazusRaidplanerDBlocal = {}
AchchazusRaidplanerDBbackup = {}
Datacheck = {}

StaticPopupDialogs["CONFORM_FIRSTLOAD"] = {
  text = ARP_WARNING_FIRSTLOAD,
  button1 = ARP_YES,
  button2 = ARP_NO,
  OnAccept = function()
      ARP_StartFirstload()
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3, 
}

local RegisteredRaids = {
{
}
}

local EventCounter = 0 
local firsttime = true
local outdatet = false
local playerClass, englishClass = UnitClass("player");
local playerName = UnitName("player");

local RegistrationButtonText = ARP_REGISTRATION
local UnregistrationButtonText = ARP_UNREGISTRATION

local Compresser = LibStub:GetLibrary("LibCompress");
local Serializer = LibStub:GetLibrary("AceSerializer-3.0");
local LibDeflate = LibStub:GetLibrary("LibDeflate");
local configForDeflate = {level = 9};

--------------------------------------------------------------------------------
--					        		Event Handler	     	  				  --
--------------------------------------------------------------------------------

local RelevantEvents = {
    "PLAYER_ENTERING_WORLD",
    "PLAYER_LOGOUT",
    "GUILD_ROSTER_UPDATE",
	"ADDON_LOADED",
}

local EventListener = ARP_EventListener or CreateFrame("FRAME", "ARP_EventListener");

function EventListener:RegisterEvents(events)
	for _, event in ipairs(events) do
		self:RegisterEvent(event)
	end
end

local function EventHandler(self, event)

if (event == "ADDON_LOADED" and eventArgs[1] == "AchchazusRaidplaner") then
		
		print(ARP_WELCOME)
			
		if AchchazusRaidplanerDBlocal.Firstload == nil then

			ARP_FirstLoad()
			
		else
	
			ARP_NoFirstLoad()
		
		end
		
			ARP_SetMinimapButton(self)
		
		EventListener:UnregisterEvent("ADDON_LOADED");

		end
		
if (event == "PLAYER_ENTERING_WORLD" and eventArgs[1] == "AchchazusRaidplaner") then
	
	local ac = LibStub("AceComm-3.0", true)
	if ac then ac:Embed(addon) end
	
	addon:RegisterComm("ARP2", "ARPComm") 
	
	addon:RegisterComm("ARP3", "ARPComm") 
	
	addon:RegisterComm("ARPVer", "ARPComm") 
	
	addon:RegisterComm("ARPData", "ARPComm") 
	
	addon:RegisterComm("ARPSendRequest", "ARPComm") 
	
	addon:SendCommMessage("ARPVer", "VERSIONSCHECK", "GUILD", player, "BULK")

	EventListener:UnregisterEvent("PLAYER_ENTERING_WORLD")
	
	ARP_TriggerEvent()
	
end

if (event == "GUILD_ROSTER_UPDATE" and eventArgs[1] == "AchchazusRaidplaner") then
	
	if EventCounter >= 10 and AchchazusRaidplanerDBlocal.Firstload == false and AchchazusRaidplanerDBlocal.CreateMenu == false then
	print(ARP_ERROR)
	EventListener:UnregisterEvent("GUILD_ROSTER_UPDATE")
	return end
	
	
	if EventCounter >= 15 and AchchazusRaidplanerDBlocal.Firstload == true and AchchazusRaidplanerDBlocal.CreateMenu == false then
	
	guildName, guildRankName, guildRankIndex = GetGuildInfo("player");

	if tonumber(guildRankIndex) > 1 and not playerName == "Renegade" then
	print(ARP_FIRSTLOAD)
	EventListener:UnregisterEvent("GUILD_ROSTER_UPDATE")
	return end
	
	if tonumber(guildRankIndex) <= 1 or playerName == "Renegade" then
	EventListener:UnregisterEvent("GUILD_ROSTER_UPDATE")
	StaticPopup_Show ("CONFORM_FIRSTLOAD")
	end
	
	end
	
	if AchchazusRaidplanerDBlocal.GetData == false and EventCounter >= 2 and AchchazusRaidplanerDBlocal.CreateMenu == false then	
	addon:SendCommMessage("ARP3", "UPDATE", "GUILD", player, "BULK")
	end
	
	EventCounter = EventCounter + 1

end

if (event == "PLAYER_LOGOUT" and eventArgs[1] == "AchchazusRaidplaner") then

if AchchazusRaidplanerDBlocal.UpdateDate == true then

	count = 0
	
	for key in pairs(AchchazusRaidplanerDBbackup) do
	count = count + 1
	end
	
	for n = count, 1, -1 do
	table.remove(AchchazusRaidplanerDBbackup)
	end

	count = 0
	
	for key in pairs(AchchazusRaidplanerDB) do
	count = count + 1
	end
	
	for n = 1, count, 1 do
	table.insert(AchchazusRaidplanerDBbackup, n, AchchazusRaidplanerDB[n]) 
	end
	
	table.insert(AchchazusRaidplanerDBbackup, date("%d/%m/%y %H:%M:%S"))
	
	EventListener:UnregisterEvent("PLAYER_LOGOUT")

end

end

end

--------------------------------------------------------------------------------
--					        		Function Sector	     	  				  --
--------------------------------------------------------------------------------

function ARP_StartFirstload()

	print(ARP_FIRSTLOADSTART)
	AchchazusRaidplanerDBlocal.GetData = true
	ARP_getFraction()
	
end

function ARP_FirstLoad()     							    -- Set Status of Locals
	
	AchchazusRaidplanerDBlocal.englishClass = englishClass
	AchchazusRaidplanerDBlocal.playerName = playerName
	AchchazusRaidplanerDBlocal.Anmeldung = ""
	AchchazusRaidplanerDBlocal.RegistrationClass = ""
	AchchazusRaidplanerDBlocal.Registered = false
	AchchazusRaidplanerDBlocal.Firstload = true
	AchchazusRaidplanerDBlocal.Start = true
	AchchazusRaidplanerDBlocal.count = 0
	AchchazusRaidplanerDBlocal.Page = 1
	AchchazusRaidplanerDBlocal.StartPage = 1
	AchchazusRaidplanerDBlocal.GetData = false
	AchchazusRaidplanerDBlocal.CreateMenu = false
	RegisteredRaids[1][AchchazusRaidplanerDBlocal.Page] = false
	AchchazusRaidplanerDB[1] = {}
	AchchazusRaidplanerDB[1][1] = "Raidname"
	AchchazusRaidplanerDB[1][2] = "23.12.19 19:00"
	AchchazusRaidplanerDBlocal.ApprovedColorR = 0
	AchchazusRaidplanerDBlocal.ApprovedColorG = 1
	AchchazusRaidplanerDBlocal.ApprovedColorB = 0
	AchchazusRaidplanerDBlocal.ApprovedColorA = 1
	AchchazusRaidplanerDBlocal.ShamanColor = false
	AchchazusRaidplanerDBlocal.ShamanColorR = 0.96
	AchchazusRaidplanerDBlocal.ShamanColorG = 0.55
	AchchazusRaidplanerDBlocal.ShamanColorB = 0.73
	AchchazusRaidplanerDBlocal.UpdateDate = false
	AchchazusRaidplanerDBlocal.Test = false
	AchchazusRaidplanerDBlocal.datasender = "Empty"
	AchchazusRaidplanerDBlocal.FocusClass = "ALL"
	
	mm = date("%m")
	year = date("%Y")
	
	AchchazusRaidplanerDBlocal.ShowMonth = mm
	AchchazusRaidplanerDBlocal.Year = year
	AchchazusRaidplanerDBlocal.InCalenderSave = true
	AchchazusRaidplanerDBlocal.InCalender = true
	AchchazusRaidplanerDBlocal.AnimationSave = true

end

function ARP_NoFirstLoad()									-- Set Status of Locals after Reload

	AchchazusRaidplanerDBlocal.englishClass = englishClass
	AchchazusRaidplanerDBlocal.playerName = playerName
	AchchazusRaidplanerDBlocal.Start = true
	AchchazusRaidplanerDBlocal.fromSend = false
	AchchazusRaidplanerDBlocal.Page = 1
	AchchazusRaidplanerDBlocal.GetData = false
	AchchazusRaidplanerDBlocal.CreateMenu = false
	AchchazusRaidplanerDBlocal.UpdateDate = false
	AchchazusRaidplanerDBlocal.Test = false
	AchchazusRaidplanerDBlocal.FocusClass = "ALL"
	
	mm = date("%m")
	year = date("%Y")
	
	AchchazusRaidplanerDBlocal.ShowMonth = mm
	AchchazusRaidplanerDBlocal.Year = year
	
	if AchchazusRaidplanerDBlocal.InCalenderSave == false then
		AchchazusRaidplanerDBlocal.InCalender = false
	else
		AchchazusRaidplanerDBlocal.InCalender = true
	end

end
	
function ARP_SetMinimapButton(self) 					    -- Set MinumapButton

		local ldb = LibStub:GetLibrary("LibDataBroker-1.1", true)
		if not ldb then return end

		local plugin = ldb:NewDataObject(addonName, {
		type = "data source",
		text = "0",
		icon = "Interface\\AddOns\\AchchazusRaidplaner\\Media\\icon",
		})
		
		function plugin.OnClick(self, button)
			if AchchazusRaidplanerDBlocal.CreateMenu == true then
				if not ARP_MainFrame:IsShown() then
					ARP_UpdateUI()
					ARP_MainFrame:Show()
					PlaySound(839)
				else 
					ARP_UpdateUI()
					ARP_MainFrame:Hide()
					PlaySound(840)
				end
			end
		end
		
		local icon = LibStub("LibDBIcon-1.0", true)
		if not icon then 
			return end
		if not AchchazusRaidplanerDBminimap then 
			AchchazusRaidplanerDBminimap = {} 
		end
		
		icon:Register(addonName, plugin, AchchazusRaidplanerDBminimap)
		
		
		do
		local hint = ARP_HINT
		
		function plugin.OnTooltipShow(Tooltip)
		Tooltip:AddLine("ARP "..ARP_VERSION)
		Tooltip:AddLine(" ")
		Tooltip:AddLine(hint, 0, 191, 255, 1)
		end
		end

end

function ARP_TriggerEvent() 								-- TriggerEvent // I think not needed
SortGuildRoster("Name")
end

function ARP_getFraction()									-- Horde or Alliance

englishFaction, localizedFaction = UnitFactionGroup("player")

if englishFaction == "Horde" then

AchchazusRaidplanerDBclass = {
	cH = {
		r = 0.67,
		g = 0.83,
		b = 0.45,
		name = "Hunter",
		realname = ARP_HUNTER,
	},
	cP = {
		r = 1,
		g = 1, 
		b = 1, 
		name = "Priest",
		realname = ARP_PRIEST,
	},
	cS = {
		r = AchchazusRaidplanerDBlocal.ShamanColorR,
		g = AchchazusRaidplanerDBlocal.ShamanColorG,
		b = AchchazusRaidplanerDBlocal.ShamanColorB,
		name = "Shaman",
		realname = ARP_SHAMAN,
	},	
	cD = {
		r = 1,
		g = 0.49,
		b = 0.04,
		name = "Druid",
		realname = ARP_DRUID, 
	},	
	cR = {
		r = 1,
		g = 0.96,
		b = 0.41,
		name = "Rogue",
		realname = ARP_ROGUE,
	},	
	cK = {
		r = 0.78,
		g = 0.61,
		b = 0.43,
		name = "Warrior",
		realname = ARP_WARRIOR,
	},		
	cM = {
		r = 0.25,
		g = 0.78,
		b = 0.92,
		name = "Mage",
		realname = ARP_MAGE,
	},		
	cW = {
		r = 0.53,
		g = 0.53,
		b = 0.93,
		name = "Warlock",
		realname = ARP_WARLOCK,
	},
	cA = {
		r = 0.6,
		g = 0,
		b = 0.1,
		name = "Away",
		realname = ARP_AWAY,
	},
}

ARP_CreateMenu()
end

if englishFaction == "Alliance" then

AchchazusRaidplanerDBclass = {
	cH = {
		r = 0.67,
		g = 0.83,
		b = 0.45,
		name = "Hunter",
		realname = ARP_HUNTER,
	},
	cP = {
		r = 1,
		g = 1, 
		b = 1, 
		name = "Priest",
		realname = ARP_PRIEST,
	},
	cB = {
		r = 0.96,
		g = 0.55,
		b = 0.73,
		name = "Paladin",
		realname = ARP_PALADIN,
	},	
	cD = {
		r = 1,
		g = 0.49,
		b = 0.04,
		name = "Druid",
		realname = ARP_DRUID, 
	},	
	cR = {
		r = 1,
		g = 0.96,
		b = 0.41,
		name = "Rogue",
		realname = ARP_ROGUE,
	},	
	cK = {
		r = 0.78,
		g = 0.61,
		b = 0.43,
		name = "Warrior",
		realname = ARP_WARRIOR,
	},		
	cM = {
		r = 0.25,
		g = 0.78,
		b = 0.92,
		name = "Mage",
		realname = ARP_MAGE,
	},		
	cW = {
		r = 0.53,
		g = 0.53,
		b = 0.93,
		name = "Warlock",
		realname = ARP_WARLOCK,
	},
	cA = {
		r = 1,
		g = 1,
		b = 1,
		name = "Away",
		realname = ARP_AWAY,
	},		
}

ARP_CreateMenu()
end

end

function addon:ARPComm(prefix, message, channel, sender)    -- Addon communication
local LibDeflate = LibStub:GetLibrary ("LibDeflate")
local LibAceSerializer = LibStub:GetLibrary ("AceSerializer-3.0")
	
	if prefix == "ARPVer"  and channel == "GUILD" and  firsttime == true and message ~= "VERSIONSCHECK" then
	
		if string.match(sender, playerName) then
			return
		end

		if tonumber(message) > tonumber(ARP_VERSION_CHECK) then
		print(ARP_OUTDATED)
		firsttime = false
		outdatet = true
		end
		
		guildName, guildRankName, guildRankIndex = GetGuildInfo("player");
		
		if tonumber(guildRankIndex) <= 1 or playerName == "Renegade" and ARP_VERSION_CHECK ~= message then
			if VersionCheckMember == true then
			
			if not VersionCheck:IsShown() then
				VersionCheckMember = false
				return
			end
			
				if CheckVersionMember == true then
				
				RaidEntrys = 0
				
					for key in pairs(AchchazusRaidplanerDB) do
						RaidEntrys = RaidEntrys + 1
					end

				for n = RaidEntrys, 1, 1 do
				table.remove(DataCheckMemberVersion)
				end
				
				end
			
				if DataCheckMemberVersion == nil then
					DataCheckMemberVersion = {}
				end
			
				count = 0
			
				for key in pairs(DataCheckMemberVersion) do
					count = count + 1
				end
				
				if count == 0 then
					table.insert(DataCheckMemberVersion, 1, sender.."="..message)
					
					ARP_UpdateVersionCheckMember()
				end
				
				for n = 1, count, 1 do
				
				length = string.len(DataCheckMemberVersion[n])
				
					if string.match(string.sub(DataCheckMemberVersion[n], 1, math.floor(length - 4)), sender) then
						found = true
					end
					
					if count == n and found ~= true then
					
						table.insert(DataCheckMemberVersion, 1, sender.."="..message)
			
						table.sort(DataCheckMemberVersion)
			
						ARP_UpdateVersionCheckMember()
						
						break
					
					end
				end
				
			end
		end
		
	end
	
	if prefix == "ARPVer"  and channel == "GUILD" and message == "VERSIONSCHECK" then
		
		if string.match(sender, playerName) then
			return
		end
		
		addon:SendCommMessage("ARPVer", ARP_VERSION_CHECK, "GUILD", player, "BULK")
	
	end

	if prefix == "ARPSendRequest" and channel == "GUILD" and string.match(playerName, message) then
	
	AchchazusRaidplanerDBlocal.GetData = false
	AchchazusRaidplanerDBlocal.UpdateDate = true

	local RaidEntrysBackup = 0

	for key in pairs(AchchazusRaidplanerDBbackup) do
		RaidEntrysBackup = RaidEntrysBackup + 1
	end

	local RaidEntrysBackup = 0

	for key in pairs(AchchazusRaidplanerDBbackup) do
		RaidEntrysBackup = RaidEntrysBackup + 1
	end

	local RaidEntrys = 0

	for key in pairs(AchchazusRaidplanerDB) do
		RaidEntrys = RaidEntrys + 1
	end

	if RaidEntrys < RaidEntrysBackup then
	table.remove(AchchazusRaidplanerDBbackup, RaidEntrysBackup)
	end

	local LibDeflate = LibStub:GetLibrary ("LibDeflate")
	local LibAceSerializer = LibStub:GetLibrary ("AceSerializer-3.0")
	
	if (LibDeflate and LibAceSerializer) then
		local dataSerialized = LibAceSerializer:Serialize (AchchazusRaidplanerDBbackup)
		if (dataSerialized) then
			local dataCompressed = LibDeflate:CompressDeflate (dataSerialized, {level = 9})
			if (dataCompressed) then
					local dataEncoded = LibDeflate:EncodeForPrint (dataCompressed)
					local dataEncodedChat = LibDeflate:EncodeForWoWAddonChannel (dataCompressed)		
					
					 SendChatMessage("Spieler: "..playerName.." hat gerade die Syncronisation gestartet" ,"GUILD")
					 ARP_Globals.SendUpdate(dataEncodedChat)
			end
		end
	end
	
	
	end
	
	if prefix == "ARPData" and channel == "GUILD" and message == "DATAUPGRADE" then
		
		if string.match(sender, playerName) then
			return
		end
		
		local RaidEntrysBackup = 0

		for key in pairs(AchchazusRaidplanerDBbackup) do
		RaidEntrysBackup = RaidEntrysBackup + 1
		end
		
		if AchchazusRaidplanerDBbackup[RaidEntrysBackup] ~= nil then
		addon:SendCommMessage("ARPData", AchchazusRaidplanerDBbackup[RaidEntrysBackup], "GUILD", player, "BULK")
		end
		
	end
	
	if prefix == "ARPData" and channel == "GUILD" and message ~= "DATAUPGRADE" then
	
		if string.match(sender, playerName) then
			return
		end
		
		guildName, guildRankName, guildRankIndex = GetGuildInfo("player");

		if tonumber(guildRankIndex) <= 1 or playerName == "Renegade" then
		
			if AchchazusRaidplanerDBlocal.CheckData == true then
				AchchazusRaidplanerDBlocal.CheckData = false
				Datacheck = {}
			end
		
			if Datacheck == nil then
				Datacheck = {}
			end
		
			table.insert(Datacheck, 1, message.." = "..sender)
		
			table.sort(Datacheck)
		
			count = 0
			for key, value in pairs(Datacheck) do
				count = count + 1
			end
		
			AchchazusRaidplanerDBlocal.transfer = Datacheck[count]
		
			ARP_Globals.UpgradeText()
		
		end
	end
	
	if prefix == "ARP2" and channel == "GUILD" and message ~= "UPDATE" then
		
		if string.match(sender, playerName) then
			return
		end
		
		
		local dataDecodeChat = LibDeflate:DecodeForWoWAddonChannel (message)
		if (not dataDecodeChat) then
			print(ARP_ERROR_DECODE)
			return 
		end
		
		local dataDecompressedChat = LibDeflate:DecompressDeflate (dataDecodeChat)
		if (not dataDecompressedChat) then
			print(ARP_ERROR_UNCOMPRESS)
			return 
		end
		
		local okay, datachat = LibAceSerializer:Deserialize (dataDecompressedChat)
		if (not okay) then
			print(ARP_ERROR_UNSERIALIZE)
			return 
		end	

		AchchazusRaidplanerDB = datachat
		
		if AchchazusRaidplanerDBlocal.GetData == true and AchchazusRaidplanerDBlocal.Firstload == false and AchchazusRaidplanerDBlocal.CreateMenu == true then
		AchchazusRaidplanerDBlocal.UpdateDate = true
		ARP_UpdateUI()
		return
		end
		
	end
		
	if prefix == "ARP3" and channel == "GUILD" and message ~= "UPDATE" and AchchazusRaidplanerDBlocal.CreateMenu == false and AchchazusRaidplanerDBlocal.GetData == false then
		if string.match(sender, playerName) then
			return
		end
		
		local dataDecodeChat = LibDeflate:DecodeForWoWAddonChannel (message)
		if (not dataDecodeChat) then
			print(ARP_ERROR_DECODE)
			return 
		end
		
		local dataDecompressedChat = LibDeflate:DecompressDeflate (dataDecodeChat)
		if (not dataDecompressedChat) then
			print(ARP_ERROR_UNCOMPRESS)
			return 
		end
		
		local okay, datachat = LibAceSerializer:Deserialize (dataDecompressedChat)
		if (not okay) then
			print(ARP_ERROR_UNSERIALIZE)
			return 
		end	

		AchchazusRaidplanerDB = datachat
		
		if AchchazusRaidplanerDBlocal.GetData == false then
		   AchchazusRaidplanerDBlocal.Firstload = false
		   AchchazusRaidplanerDBlocal.GetData = true
		   SortGuildRoster("Name")
		end
		
		if AchchazusRaidplanerDBlocal.GetData == true and AchchazusRaidplanerDBlocal.Firstload == false and AchchazusRaidplanerDBlocal.CreateMenu == false and AchchazusRaidplanerDBlocal.Test == false then
		   AchchazusRaidplanerDBlocal.Test = true
		   EventListener:UnregisterEvent("GUILD_ROSTER_UPDATE")
		   print(ARP_SUCESS)
		   addon:SendCommMessage("ARPVer", ARP_VERSION_CHECK, "GUILD", player, "BULK")
		   AchchazusRaidplanerDBlocal.Firstload = false
		   ARP_getFraction()
		return end
		
	end
		
	if prefix == "ARP3" and channel == "GUILD" and message == "UPDATE" and AchchazusRaidplanerDBlocal.GetData == true then
	
		if string.match(sender, playerName) then
			return
		end
	
		local LibDeflate = LibStub:GetLibrary ("LibDeflate")
		local LibAceSerializer = LibStub:GetLibrary ("AceSerializer-3.0")
	
		if (LibDeflate and LibAceSerializer) then
			local dataSerialized = LibAceSerializer:Serialize (AchchazusRaidplanerDB)
			if (dataSerialized) then
				local dataCompressed = LibDeflate:CompressDeflate (dataSerialized, {level = 9})
				if (dataCompressed) then
					local dataEncoded = LibDeflate:EncodeForPrint (dataCompressed)
					local dataEncodedChat = LibDeflate:EncodeForWoWAddonChannel (dataCompressed)		
					
					ARP_SendUpdate(dataEncodedChat)
					
				end
			end
		end	
	end

end

function ARP_SendMessage()									-- Prepair Send Message
local LibDeflate = LibStub:GetLibrary ("LibDeflate")
local LibAceSerializer = LibStub:GetLibrary ("AceSerializer-3.0")
	
	if (LibDeflate and LibAceSerializer) then
		local dataSerialized = LibAceSerializer:Serialize (AchchazusRaidplanerDB)
		if (dataSerialized) then
			local dataCompressed = LibDeflate:CompressDeflate (dataSerialized, {level = 9})
			if (dataCompressed) then
					local dataEncoded = LibDeflate:EncodeForPrint (dataCompressed)
					local dataEncodedChat = LibDeflate:EncodeForWoWAddonChannel (dataCompressed)		
					
					ARP_Send(dataEncodedChat)
			end
		end
	end
end
 
function ARP_Send(dataEncodedChat)							-- Send message
addon:SendCommMessage("ARP2", dataEncodedChat, "GUILD", player, "BULK")
end

function ARP_SendUpdate(dataEncodedChat)					-- send Update Message
addon:SendCommMessage("ARP3", dataEncodedChat, "GUILD", player, "BULK")
end

function ARP_toConfirmed(self)								-- Move Players to Confirmed

guildName, guildRankName, guildRankIndex = GetGuildInfo("player");

if tonumber(guildRankIndex) > 1 then
print(ARP_NO_RAIDLEADER)
return end


for key, value in pairs(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page]) do 
	if value ~= "" then
		if string.match(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][key], self:GetText()) then
			AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][key] = string.gsub(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][key], "%.f", "%.t")
			self:SetText("Test")
			self:Hide()
			ARP_SendMessage()
			ARP_UpdateUI()
			return end
		end
	end
end

function ARP_toUnconfirmed(self)							-- Move Players to Approved

guildName, guildRankName, guildRankIndex = GetGuildInfo("player");

if tonumber(guildRankIndex) > 1 then
print(ARP_NO_RAIDLEADER)
return end

for key, value in pairs(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page]) do 
	if value ~= "" then
		if string.match(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][key], self:GetText()) then
			AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][key] = string.gsub(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][key], "%.t", "%.f")
			self:SetText("Test")
			self:Hide()
			ARP_SendMessage()
			ARP_UpdateUI()
			return end
		end
	end
end

function ARP_GetDayofWeek(dd, mm, yy) 						-- Get Day of Date (Mon,.,.,Sun)

  local days = ARP_DAYS

  local mmx = mm
  
  if tonumber(mm) == 1 then  
	mmx = 13
	yy = yy-1  
  end
  
  if tonumber(mm) == 2 then
	mmx = 14
	yy = yy-1  
  end
 

  local val8 = dd + (mmx*2) +  math.floor(((mmx+1)*3)/5)   + yy + math.floor(yy/4)  - math.floor(yy/100)  + math.floor(yy/400) + 2
  local val9 = math.floor(val8/7)
  local dw = val8-(val9*7) 

  if (dw == 0) then
    dw = 7
  end

  return dw, days[dw]
end

function ARP_GetDaysInMonth(month, year)
  local days_in_month = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 }   
  local d = days_in_month[month]
   
  if (tonumber(month) == 2) then
    if (year % 4) == 0 then
       d = 29
    end
  end

  return d  
end

function ARP_RaidEntrys()									-- count how many Raids 

local RaidEntrys = 0

for key in pairs(AchchazusRaidplanerDB) do
RaidEntrys = RaidEntrys + 1
end

return RaidEntrys
end

function ARP_Round(number, decimals)
    return (("%%.%df"):format(decimals)):format(number)
end

--------------------------------------------------------------------------------
--					        		Sound Function Sector 	  				  --
--------------------------------------------------------------------------------

function ARP_PlayChanceSound()

PlaySound(829)

end

function ARP_PlayCloseSound()

PlaySound(840)

end

function ARP_PlayShowSound()

PlaySound(839)

end

function ARP_PlayShowButtons()

PlaySound(855)

end

function ARP_PlayTabButtons()

PlaySound(841)

end

--------------------------------------------------------------------------------
--					        		Global Function Sector 	  				  --
--------------------------------------------------------------------------------

ARP_Globals={}
function ARP_Globals.SendUpdate(dataEncodedChat)
	addon:SendCommMessage("ARP3", dataEncodedChat, "GUILD", player, "BULK")
	return
end

function ARP_Globals.DataUpgrade()
	addon:SendCommMessage("ARPData", "DATAUPGRADE", "GUILD", player, "BULK")
	return
end

function ARP_Globals.DataSender(datasender)
	addon:SendCommMessage("ARPSendRequest", datasender, "GUILD", player, "BULK")
	return
end

function ARP_Globals.UpdateUI()
ARP_UpdateUI()
end


--------------------------------------------------------------------------------
--					        		GUI Sector	     	  		     		  --
--------------------------------------------------------------------------------


function ARP_CreateMenu()

AchchazusRaidplanerDBlocal.CreateMenu = true

ARP_MainFrame = CreateFrame("Frame", "Achchazu Mainframe", UIParent, "BasicFrameTemplateWithInset");

SLASH_PANE1 = "/arp"
SLASH_PANE2 = "/achchazu"

SlashCmdList.PANE = function(arg)
    if not ARP_MainFrame:IsShown() then
		ARP_UpdateUI()
		ARP_MainFrame:Show()
		ARP_PlayShowSound()
	else 
		ARP_UpdateUI()
		ARP_MainFrame:Hide()
		ARP_PlayCloseSound()
    end
end

ARP_MainFrame:Hide()
ARP_MainFrame:SetMovable(true)
ARP_MainFrame:SetUserPlaced(isUserPlaced);
ARP_MainFrame:EnableMouse(true)
ARP_MainFrame:RegisterForDrag("LeftButton")
ARP_MainFrame:SetScript("OnDragStart", ARP_MainFrame.StartMoving)
ARP_MainFrame:SetScript("OnDragStop", ARP_MainFrame.StopMovingOrSizing)
ARP_MainFrame:SetSize(850, 500);
ARP_MainFrame:SetFrameLevel(8)
ARP_MainFrame:SetPoint("CENTER", UIParent, "CENTER")


ARP_MainFrame.title = ARP_MainFrame:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
ARP_MainFrame.title:SetPoint("LEFT", ARP_MainFrame.TitleBg, "LEFT", 5, 0);
ARP_MainFrame.title:SetText("Achchazus Raidplaner "..ARP_VERSION);

ARP_MainFrame.title2 = ARP_MainFrame:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
ARP_MainFrame.title2:SetPoint("RIGHT", ARP_MainFrame.TitleBg, "RIGHT", -5, 0);
ARP_MainFrame.title2:SetText("from Renegade@Lucifron");

ARP_MainFrame.ScrollFrame = CreateFrame("ScrollFrame", nil, ARP_MainFrame, "UIPanelScrollFrameTemplate");
ARP_MainFrame.ScrollFrame:SetPoint("TOPLEFT", ARP_MainFrame, "TOPLEFT", 4, -8);
ARP_MainFrame.ScrollFrame:SetPoint("BOTTOMRIGHT", ARP_MainFrame, "BOTTOMRIGHT", -3, 4);
ARP_MainFrame.ScrollFrame:SetClipsChildren(true);
ARP_MainFrame.ScrollFrame:SetScript("OnMouseWheel", ScrollFrame_OnMouseWheel);

ARP_MainFrame.ScrollFrame.ScrollBar:ClearAllPoints();
ARP_MainFrame.ScrollFrame.ScrollBar:SetPoint("TOPLEFT", ARP_MainFrame.ScrollFrame, "TOPRIGHT", -12, -35);
ARP_MainFrame.ScrollFrame.ScrollBar:SetPoint("BOTTOMRIGHT", ARP_MainFrame.ScrollFrame, "BOTTOMRIGHT", -7, 18);

local function Tab_OnClick(self)
	PanelTemplates_SetTab(self:GetParent(), self:GetID());
		
	local scrollChild = ARP_MainFrame.ScrollFrame:GetScrollChild();
	if (scrollChild) then
		scrollChild:Hide();
	end
	
	ARP_PlayTabButtons()

	ARP_MainFrame.ScrollFrame:SetScrollChild(self.ARP_Content);
	self.ARP_Content:Show();	
end

local function SetTabs(frame, numTabs, ...)
	frame.numTabs = numTabs;
	
	local ARP_Contents = {};
	local frameName = frame:GetName();
	
	
	for i = 1, numTabs do	
		local tab = CreateFrame("Button", frameName.."Tab"..i, frame, "CharacterFrameTabButtonTemplate");
		
		tab:SetID(i);
		tab:SetText(select(i, ...));
		tab:SetScript("OnClick", Tab_OnClick);
		tab:SetFrameLevel(9)
		tab:Disable()
		
		
		tab.ARP_Content = CreateFrame("Frame", nil, ARP_MainFrame.ScrollFrame);
		tab.ARP_Content:SetSize(830, 480);
		tab.ARP_Content:Hide();

		table.insert(ARP_Contents, tab.ARP_Content);

		if (i == 1) then
			tab:SetPoint("TOPLEFT", ARP_MainFrame, "BOTTOMLEFT", 5, 7);
		else
			tab:SetPoint("TOPLEFT", _G[frameName.."Tab"..(i - 1)], "TOPRIGHT", -14, 0);
		end	

	end

	Tab_OnClick(_G[frameName.."Tab1"]);
	
	return unpack(ARP_Contents);

end

local ARP_Content1, ARP_Content2, ARP_Content3 = SetTabs(ARP_MainFrame, 3, ARP_RAIDPLANER_TAB, ARP_RAIDLEADER_TAB, ARP_OPTION_TAB);

local ARP_Content = {
    ARP_Content1,
    ARP_Content2,
    ARP_Content3,
};

for n = 1, 3, 1 do
    ARP_Content[n]["RaidID"] = ARP_Content[n]:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
	ARP_Content[n]["RaidID"]:SetPoint("TOPLEFT", ARP_Content[n], "TOPLEFT", 40, -40);
	ARP_Content[n]["RaidID"]:SetTextColor(1, 1, 0)
	ARP_Content[n]["RaidID"]:SetText(ARP_RAIDID..AchchazusRaidplanerDBlocal.Page)

	ARP_Content[n]["RaidDate"] = ARP_Content[n]:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
	ARP_Content[n]["RaidDate"]:SetPoint("LEFT", ARP_Content[n]["RaidID"], 75, 0);
	ARP_Content[n]["RaidDate"]:SetTextColor(1, 1, 0)
	ARP_Content[n]["RaidDate"]:SetText(ARP_RAIDDATE.. AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][2])

	ARP_Content[n]["RaidName"] = ARP_Content[n]:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
	ARP_Content[n]["RaidName"]:SetPoint("RIGHT", ARP_Content[n]["RaidDate"], 125, 0);
	ARP_Content[n]["RaidName"]:SetTextColor(1, 1, 0)
	ARP_Content[n]["RaidName"]:SetText(ARP_RAIDNAME.. AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][1])
end

count = 0

for key, value in pairs(AchchazusRaidplanerDBclass) do 
	    ARP_Content1[key] = ARP_Content1:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
		ARP_Content1[key]:SetPoint("CENTER", ARP_Content1.RaidID, "CENTER", count, -30);
		ARP_Content1[key]:SetTextColor(AchchazusRaidplanerDBclass[key]["r"], AchchazusRaidplanerDBclass[key]["g"], AchchazusRaidplanerDBclass[key]["b"])
		ARP_Content1[key]:SetText(AchchazusRaidplanerDBclass[key]["realname"])
	count = count + 85
end

for n = 1, 2, 1 do
	ARP_Content[n]["RaidIDCounterBack"] = CreateFrame("Button", nil, ARP_Content[n], "UIPanelButtonTemplate");
	ARP_Content[n]["RaidIDCounterBack"]:SetPoint("BOTTOMLEFT", ARP_Content[n], "BOTTOMLEFT", 20, 20);
	ARP_Content[n]["RaidIDCounterBack"]:SetText("<")
	ARP_Content[n]["RaidIDCounterBack"]:SetNormalFontObject("GameFontNormalLarge");
	ARP_Content[n]["RaidIDCounterBack"]:SetHighlightFontObject("GameFontHighlightLarge");
ARP_Content[n]["RaidIDCounterBack"]:SetScript("OnClick", function()

ARP_PlayChanceSound()

count = tonumber(ARP_RaidEntrys())

if AchchazusRaidplanerDBlocal.Page ~= 1 then
	for key, value in pairs(AchchazusRaidplanerDBclass) do 
		for i = 1, 25, 1 do
		ARP_Content1[key..i]:SetText("")
		end
	end
end

if AchchazusRaidplanerDBlocal.Page ~= 1 then
	AchchazusRaidplanerDBlocal.Page = AchchazusRaidplanerDBlocal.Page - 1
	for n = 1, 79, 1 do
		if ARP_Content2["Registered"..n]:GetText() == AchchazusRaidplanerDBlocal.Anmeldung then
			ARP_Content2["Registered"..n]:SetText("Test")
		end
		if ARP_Content2["Confirmed"..n]:GetText() == AchchazusRaidplanerDBlocal.Anmeldung then
			ARP_Content2["Confirmed"..n]:SetText("Test")
		end
	end
end
ARP_UpdateUI()
end )

	ARP_Content[n]["Registered"] = ARP_Content[n]:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
	ARP_Content[n]["Registered"]:SetPoint("LEFT", ARP_Content[n]["RaidIDCounterBack"], "LEFT", 125, 0);
	ARP_Content[n]["Registered"]:SetTextColor(1, 1, 1)
	ARP_Content[n]["Registered"]:SetText(ARP_REGISTERED_PLAYER..AchchazusRaidplanerDBlocal.count )

	ARP_Content[n]["Approved"] = ARP_Content[n]:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
	ARP_Content[n]["Approved"]:SetPoint("LEFT", ARP_Content[n]["Registered"], "LEFT", 0, -12);
	ARP_Content[n]["Approved"]:SetTextColor(1, 1, 1)
	ARP_Content[n]["Approved"]:SetText(ARP_APPROVED_PLAYER)

	ARP_Content[n]["RaidIDCounterForward"] = CreateFrame("Button", nil, ARP_Content[n], "UIPanelButtonTemplate");
	ARP_Content[n]["RaidIDCounterForward"]:SetPoint("BOTTOMRIGHT", ARP_Content[n], "BOTTOMRIGHT", -20, 20);
	ARP_Content[n]["RaidIDCounterForward"]:SetText(">")
	ARP_Content[n]["RaidIDCounterForward"]:SetNormalFontObject("GameFontNormalLarge");
	ARP_Content[n]["RaidIDCounterForward"]:SetHighlightFontObject("GameFontHighlightLarge");
	
ARP_Content[n]["RaidIDCounterForward"]:SetScript("OnClick", function()

ARP_PlayChanceSound()

count = tonumber(ARP_RaidEntrys())

if AchchazusRaidplanerDBlocal.Page < count then
	for key, value in pairs(AchchazusRaidplanerDBclass) do 
		for i = 1, 25, 1 do
		ARP_Content1[key..i]:SetText("")
		end
	end
end

if AchchazusRaidplanerDBlocal.Page < count then

	AchchazusRaidplanerDBlocal.Page = AchchazusRaidplanerDBlocal.Page + 1
	
	for n = 1, 79, 1 do
		if ARP_Content2["Registered"..n]:GetText() == AchchazusRaidplanerDBlocal.Anmeldung then
			ARP_Content2["Registered"..n]:SetText("Test")
		end
		if ARP_Content2["Confirmed"..n]:GetText() == AchchazusRaidplanerDBlocal.Anmeldung then
			ARP_Content2["Confirmed"..n]:SetText("Test")
		end
	end	
end
ARP_UpdateUI()
end )

local count = tonumber(ARP_RaidEntrys())

	ARP_Content[n]["RaidIDCounter"] = ARP_Content[n]:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
	ARP_Content[n]["RaidIDCounter"]:SetPoint("LEFT", ARP_Content[n]["RaidIDCounterForward"], "LEFT", -125, 0);
	ARP_Content[n]["RaidIDCounter"]:SetTextColor(1, 1, 1)
	ARP_Content[n]["RaidIDCounter"]:SetText(ARP_RAID.." 1 "..ARP_FROM.." "..count)

end

	ARP_Content2.Menu = ARP_Content2:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
	ARP_Content2.Menu:SetPoint("CENTER", ARP_Content2, "CENTER", 0, 150);
	ARP_Content2.Menu:SetTextColor(1, 1, 0)
	ARP_Content2.Menu:SetText(ARP_APPROVED_MENU)

local count = -50

for key, value in pairs(AchchazusRaidplanerDBclass) do 
	if key ~= "cA" then
	    ARP_Content2[key] = CreateFrame("FRAME",nil, ARP_Content2, "OptionsBoxTemplate")
		ARP_Content2[key]:SetSize(100, 30);
		ARP_Content2[key]:SetPoint("CENTER", ARP_Content2.Menu, "CENTER", 0, count)
	count = count - 25
	    ARP_Content2[key].text = ARP_Content2[key]:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
		ARP_Content2[key].text:SetPoint("CENTER", ARP_Content2[key], "CENTER", 0, 0);
		ARP_Content2[key].text:SetTextColor(AchchazusRaidplanerDBclass[key]["r"], AchchazusRaidplanerDBclass[key]["g"], AchchazusRaidplanerDBclass[key]["b"])
		ARP_Content2[key].text:SetText(AchchazusRaidplanerDBclass[key]["realname"])
	
		ARP_Content2["Registered"..key] = ARP_Content2:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
		ARP_Content2["Registered"..key]:SetPoint("CENTER", ARP_Content2[key], "CENTER", -65, 0);
		ARP_Content2["Registered"..key]:SetText("0")
		ARP_Content2["Approved"..key] = ARP_Content2:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
		ARP_Content2["Approved"..key]:SetPoint("CENTER", ARP_Content2[key], "CENTER", 65, 0);
		ARP_Content2["Approved"..key]:SetText("0")

	ARP_Content2[key]:EnableMouse(true)	
  
	ARP_Content2[key]:SetScript("OnMouseDown", function(self,button,...)

	AchchazusRaidplanerDBlocal.FocusClass = key

	ARP_UpdateUI()

	end )

end

end


	ARP_Content2.total = CreateFrame("FRAME",nil, ARP_Content2, "OptionsBoxTemplate")
	ARP_Content2.total:SetSize(100, 30);
	ARP_Content2.total:SetPoint("CENTER", ARP_Content2["cH"], "CENTER", 0, -35)
	ARP_Content2.total.text = ARP_Content2.total:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
	ARP_Content2.total.text:SetPoint("CENTER", ARP_Content2.total, "CENTER", 0, 0);
	ARP_Content2.total.text:SetTextColor(1, 1, 1)
	ARP_Content2.total.text:SetText(ARP_TOTAL)
	ARP_Content2.total:EnableMouse(true)
ARP_Content2.total:SetScript("OnMouseDown", function(self,button,...)

	AchchazusRaidplanerDBlocal.FocusClass = "ALL"
	ARP_UpdateUI()

end )	

	ARP_Content2.totalRegistered = ARP_Content2:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
	ARP_Content2.totalRegistered:SetPoint("CENTER", ARP_Content2.total, "CENTER", -65, 0);
	ARP_Content2.totalRegistered:SetText("0")

	ARP_Content2.totalApproved = ARP_Content2:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
	ARP_Content2.totalApproved:SetPoint("CENTER", ARP_Content2.total, "CENTER", 65, 0);
	ARP_Content2.totalApproved:SetText("0")

	ARP_Content2.InviteButton = CreateFrame("Button", nil, ARP_Content2, "GameMenuButtonTemplate");
	ARP_Content2.InviteButton:SetPoint("CENTER", ARP_Content2, "BOTTOM", -0, 30);
	ARP_Content2.InviteButton:SetSize(100, 30);
	ARP_Content2.InviteButton:SetText(ARP_INVITE)
	ARP_Content2.InviteButton:SetNormalFontObject("GameFontNormalLarge");
	ARP_Content2.InviteButton:SetHighlightFontObject("GameFontHighlightLarge");
ARP_Content2.InviteButton:SetScript("OnClick", function()

ARP_PlayShowButtons()

guildName, guildRankName, guildRankIndex = GetGuildInfo("player");

if not playerName == "Renegade" then
	if tonumber(guildRankIndex) > 1 then
	print(ARP_NO_RAIDLEADER)
	return end
end

for value, key in pairs(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page]) do 
	if key ~= "" then
		if string.match(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][value], "%.t") then
		length = string.len(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][value])
			if UnitInRaid(string.sub(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][value], 1, math.floor(length-5))) == nil then
				if playerName ~= string.sub(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][value], 1, math.floor(length-5)) then
					InviteUnit(string.sub(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][value], 1, math.floor(length-5))) 
					ConvertToRaid()
					SetLootMethod("master", playerName)
				end
			end
		end
	end
end

end ) 

	ARP_Content2.Selectmenu = CreateFrame('Frame', "Registered", ARP_Content2, "OptionsBoxTemplate")
	ARP_Content2.Selectmenu:SetPoint("CENTER", ARP_Content2, "CENTER", -200, 0)
	ARP_Content2.Selectmenu:SetWidth( 150 )
	ARP_Content2.Selectmenu:SetHeight( 270 )

	ARP_Content2.ScrollFrame = CreateFrame("ScrollFrame", nil, ARP_Content2.Selectmenu, "UIPanelScrollFrameTemplate");
	ARP_Content2.ScrollFrame:SetPoint("TOPLEFT", ARP_Content2.Selectmenu, "TOPLEFT", 4, -8);
	ARP_Content2.ScrollFrame:SetPoint("BOTTOMRIGHT", ARP_Content2.Selectmenu, "BOTTOMRIGHT", -3, 4);
	ARP_Content2.ScrollFrame:SetClipsChildren(true);

	ARP_Content2.ScrollFrame.ScrollBar:ClearAllPoints();
	ARP_Content2.ScrollFrame.ScrollBar:SetPoint("TOPLEFT", ARP_Content2.ScrollFrame, "TOPRIGHT", -12, -35);
	ARP_Content2.ScrollFrame.ScrollBar:SetPoint("BOTTOMRIGHT", ARP_Content2.ScrollFrame, "BOTTOMRIGHT", -7, 18);

local count = 0
childsize = 0

for  i = 1, 80, 1 do 
	count = count + 1
end

local child = CreateFrame("Frame", nil, ARP_Content2.ScrollFrame);
child:SetSize(150, math.floor(110+count*15))

ARP_Content2.ScrollFrame:SetScrollChild(child)

	ARP_Content2.RegisteredPlayer = ARP_Content2:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
	ARP_Content2.RegisteredPlayer:SetPoint("TOP", child, "TOP", 0, -3);
	ARP_Content2.RegisteredPlayer:SetTextColor(1, 0.96, 0.41)
	ARP_Content2.RegisteredPlayer:SetText(ARP_REGISTERED_PLAYER)

	ARP_Content2.confirmedmenu = CreateFrame('Frame', "Registered", ARP_Content2, "OptionsBoxTemplate")
	ARP_Content2.confirmedmenu:SetPoint("CENTER", ARP_Content2, "CENTER", 200, 0)
	ARP_Content2.confirmedmenu:SetWidth( 150 )
	ARP_Content2.confirmedmenu:SetHeight( 270 )

	ARP_Content2.ScrollFrameconfirmedmenu = CreateFrame("ScrollFrame", nil, ARP_Content2.confirmedmenu, "UIPanelScrollFrameTemplate");
	ARP_Content2.ScrollFrameconfirmedmenu:SetPoint("TOPLEFT", ARP_Content2.confirmedmenu, "TOPLEFT", 4, -8);
	ARP_Content2.ScrollFrameconfirmedmenu:SetPoint("BOTTOMRIGHT", ARP_Content2.confirmedmenu, "BOTTOMRIGHT", -3, 4);
	ARP_Content2.ScrollFrameconfirmedmenu:SetClipsChildren(true);

	ARP_Content2.ScrollFrameconfirmedmenu.ScrollBar:ClearAllPoints();
	ARP_Content2.ScrollFrameconfirmedmenu.ScrollBar:SetPoint("TOPLEFT", ARP_Content2.ScrollFrameconfirmedmenu, "TOPRIGHT", -12, -35);
	ARP_Content2.ScrollFrameconfirmedmenu.ScrollBar:SetPoint("BOTTOMRIGHT", ARP_Content2.ScrollFrameconfirmedmenu, "BOTTOMRIGHT", -7, 18);

local count = 0
childsize = 0

for  i = 1, 80, 1 do 
	count = count + 1
end

local child2 = CreateFrame("Frame", nil, ARP_Content2.ScrollFrame);
child2:SetSize(150, math.floor(110+count*15))

ARP_Content2.ScrollFrameconfirmedmenu:SetScrollChild(child2)

	ARP_Content2.confirmedPlayer = ARP_Content2:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
	ARP_Content2.confirmedPlayer:SetPoint("TOP", child2, "TOP", 0, -3);
	ARP_Content2.confirmedPlayer:SetTextColor(1, 0.96, 0.41)
	ARP_Content2.confirmedPlayer:SetText(ARP_APPROVED_PLAYER)

local count = 0
local a = -20
local length = 0

for  i = 1, 80, 1 do 
		ARP_Content2["Registered"..i] = CreateFrame("Button", "Registered"..i, ARP_Content2.ScrollFrame, "UIPanelButtonTemplate");
		ARP_Content2["Registered"..i]:SetPoint("TOP", ARP_Content2.RegisteredPlayer, "TOP", -10, math.floor(a*i));
		ARP_Content2["Registered"..i]:SetText("Test")
		ARP_Content2["Registered"..i]:SetSize(100, 15);
		ARP_Content2["Registered"..i]:SetScript("OnClick", ARP_toConfirmed);
		ARP_Content2["Registered"..i]:Hide()
end

local count = 0
local a = -20
local length = 0

for  i = 1, 80, 1 do 
		ARP_Content2["Confirmed"..i] = CreateFrame("Button", "Confirmed"..i, ARP_Content2.ScrollFrameconfirmedmenu, "UIPanelButtonTemplate");
		ARP_Content2["Confirmed"..i]:SetPoint("TOP", ARP_Content2.confirmedPlayer, "TOP", -10, math.floor(a*i));
		ARP_Content2["Confirmed"..i]:SetText("Test")
		ARP_Content2["Confirmed"..i]:SetSize(100, 15);
		ARP_Content2["Confirmed"..i]:SetScript("OnClick", ARP_toUnconfirmed);
		ARP_Content2["Confirmed"..i]:Hide()
end

local i = 1
local length = 0
	
local a = -15
local b = -20

for key, value in pairs(AchchazusRaidplanerDBclass) do 

for i = 1, 25, 1 do
		ARP_Content1[key..i] = ARP_Content1:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
		ARP_Content1[key..i]:SetPoint("CENTER", ARP_Content1[key], "CENTER", 0, math.floor(a+(b*i)));
		ARP_Content1[key..i]:SetTextColor(0.67, 0.83, 0.45)
		ARP_Content1[key..i]:SetText("")
end
end

	ARP_Content1.RegistrationButton = CreateFrame("Button", nil, ARP_Content1, "GameMenuButtonTemplate");
	ARP_Content1.RegistrationButton:SetPoint("CENTER", ARP_Content1, "BOTTOM", -0, 30);
	ARP_Content1.RegistrationButton:SetSize(100, 30);
	ARP_Content1.RegistrationButton:SetNormalFontObject("GameFontNormalLarge");
	ARP_Content1.RegistrationButton:SetHighlightFontObject("GameFontHighlightLarge");

if outdatet == true then
ARP_Content1.RegistrationButton:Disable()
end

	ARP_Content1.DDCheckBox = CreateFrame("CheckButton", "DDCheckBox", ARP_Content1, "UICheckButtonTemplate");
	ARP_Content1.DDCheckBox:SetPoint("CENTER", ARP_Content1.RegistrationButton, "CENTER", 40, 30);
	ARP_Content1.DDCheckBox:SetSize(38, 38);
	ARP_Content1.DDCheckBox:SetNormalFontObject("GameFontNormalLarge");
	ARP_Content1.DDCheckBox:SetHighlightFontObject("GameFontHighlightLarge");
	ARP_Content1.DDCheckBox:Hide()
	
ARP_Content1.DDCheckBox:SetScript("OnClick", function(self)				

ARP_PlayShowButtons()

isChecked = ARP_Content1.HealCheckBox:GetChecked()

if isChecked == true then
	ARP_Content1.HealCheckBox:SetChecked(false)
end

isChecked = ARP_Content1.TankCheckBox:GetChecked()

if isChecked == true then
	ARP_Content1.TankCheckBox:SetChecked(false)
end


end )

	ARP_Content1.DDtexture = ARP_Content1:CreateTexture()
	ARP_Content1.DDtexture:SetTexture("Interface\\AddOns\\AchchazusRaidplaner\\Media\\dd.tga")
	ARP_Content1.DDtexture:SetPoint("CENTER", ARP_Content1.DDCheckBox, "CENTER", 0, 0);
	ARP_Content1.DDtexture:SetSize(22, 22)
	ARP_Content1.DDtexture:Hide()

	ARP_Content1.HealCheckBox = CreateFrame("CheckButton", "HealCheckBox", ARP_Content1, "UICheckButtonTemplate");
	ARP_Content1.HealCheckBox:SetPoint("CENTER", ARP_Content1.RegistrationButton, "CENTER", 0, 30);
	ARP_Content1.HealCheckBox:SetSize(38, 38);
	ARP_Content1.HealCheckBox:SetNormalFontObject("GameFontNormalLarge");
	ARP_Content1.HealCheckBox:SetHighlightFontObject("GameFontHighlightLarge");
	ARP_Content1.HealCheckBox:Hide()
	
ARP_Content1.HealCheckBox:SetScript("OnClick", function(self)				

ARP_PlayShowButtons()

isChecked = ARP_Content1.DDCheckBox:GetChecked()

if isChecked == true then
	ARP_Content1.DDCheckBox:SetChecked(false)
end

isChecked = ARP_Content1.TankCheckBox:GetChecked()

if isChecked == true then
	ARP_Content1.TankCheckBox:SetChecked(false)
end

end )
	
	ARP_Content1.Healtexture = ARP_Content1:CreateTexture()
	ARP_Content1.Healtexture:SetTexture("Interface\\AddOns\\AchchazusRaidplaner\\Media\\heal.tga")
	ARP_Content1.Healtexture:SetPoint("CENTER", ARP_Content1.HealCheckBox, "CENTER", 0, 0);
	ARP_Content1.Healtexture:SetSize(22, 22)
	ARP_Content1.Healtexture:Hide()

	ARP_Content1.TankCheckBox = CreateFrame("CheckButton", "TankCheckBox", ARP_Content1, "UICheckButtonTemplate");
	ARP_Content1.TankCheckBox:SetPoint("CENTER", ARP_Content1.RegistrationButton, "CENTER", -40, 30);
	ARP_Content1.TankCheckBox:SetSize(38, 38);
	ARP_Content1.TankCheckBox:SetNormalFontObject("GameFontNormalLarge");
	ARP_Content1.TankCheckBox:SetHighlightFontObject("GameFontHighlightLarge");
	ARP_Content1.TankCheckBox:Hide()
	
ARP_Content1.TankCheckBox:SetScript("OnClick", function(self)				

ARP_PlayShowButtons()

isChecked = ARP_Content1.DDCheckBox:GetChecked()

if isChecked == true then
	ARP_Content1.DDCheckBox:SetChecked(false)
end

isChecked = ARP_Content1.HealCheckBox:GetChecked()

if isChecked == true then
	ARP_Content1.HealCheckBox:SetChecked(false)
end

end )

	ARP_Content1.Tanktexture = ARP_Content1:CreateTexture()
	ARP_Content1.Tanktexture:SetTexture("Interface\\AddOns\\AchchazusRaidplaner\\Media\\tank.tga")
	ARP_Content1.Tanktexture:SetPoint("CENTER", ARP_Content1.TankCheckBox, "CENTER", 0, 0);
	ARP_Content1.Tanktexture:SetSize(22, 22)
	ARP_Content1.Tanktexture:Hide()

	ARP_Content1.AwayCheckBox = CreateFrame("CheckButton", "Test", ARP_Content1, "UICheckButtonTemplate");
	ARP_Content1.AwayCheckBox:SetPoint("CENTER", ARP_Content1.RegistrationButton, "CENTER", 75, 0);
	ARP_Content1.AwayCheckBox:SetSize(30, 30);
	ARP_Content1.AwayCheckBox:SetNormalFontObject("GameFontNormalLarge");
	ARP_Content1.AwayCheckBox:SetHighlightFontObject("GameFontHighlightLarge");

	ARP_Content1.AwayCheckBoxText = ARP_Content1:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
	ARP_Content1.AwayCheckBoxText:SetPoint("CENTER", ARP_Content1.AwayCheckBox, "CENTER", 45, 0);
	ARP_Content1.AwayCheckBoxText:SetText(ARP_AWAY)

if AchchazusRaidplanerDBlocal.Registered == true then
ARP_Content1.RegistrationButton:SetText(UnregistrationButtonText);
end
if AchchazusRaidplanerDBlocal.Registered == false or AchchazusRaidplanerDBlocal.Firstload == true then
AchchazusRaidplanerDBlocal.Firstload = false
ARP_Content1.RegistrationButton:SetText(RegistrationButtonText)
end

	ARP_Content3.Optionen = ARP_Content3:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
	ARP_Content3.Optionen:SetPoint("CENTER", ARP_Content3, "CENTER", 0, 150);
	ARP_Content3.Optionen:SetTextColor(1, 1, 0)
	ARP_Content3.Optionen:SetText(ARP_OPTION)

	ARP_Content3.RaidID = ARP_Content3:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
	ARP_Content3.RaidID:SetPoint("LEFT", ARP_Content3, "LEFT", 50, 100);
	ARP_Content3.RaidID:SetTextColor(1, 1, 0)
	ARP_Content3.RaidID:SetText(ARP_RAIDID)

local RaidIDDropDown = CreateFrame("frame", "RaidIDDropDown", ARP_Content3, "UIDropDownMenuTemplate")
RaidIDDropDown:SetPoint("LEFT", ARP_Content3.RaidID, "LEFT", 75, 0);
UIDropDownMenu_SetText(RaidIDDropDown, "1")

RaidIDDropDown.onClick = function(self, arg1, arg2, checked)
	
	count = tonumber(ARP_RaidEntrys())
	
	UIDropDownMenu_SetText(RaidIDDropDown, arg2)
	
	if tonumber(arg2) < count then
	
	UIDropDownMenu_SetText(RaidNameDropDown, AchchazusRaidplanerDB[arg2][1])
	ARP_Content3.EditRaidDate:SetText(string.sub(AchchazusRaidplanerDB[arg2][2], 1 , 8))
	UIDropDownMenu_SetText(RaidTimeHourDropDown, string.sub(AchchazusRaidplanerDB[arg2][2] , 9, 11))
	UIDropDownMenu_SetText(RaidTimeMinDropDown, string.sub(AchchazusRaidplanerDB[arg2][2] , 13, 14))
	ARP_UpdateUI()	
	CloseDropDownMenus()
	return
	end
	
	if tonumber(arg2) > count then
	
	ARP_Content3.EditRaidDate:SetText("dd.mm.yy")
	
	ARP_UpdateUI()	
	CloseDropDownMenus()
	
	return
	end
	
end

RaidIDDropDown.initialize = function(self, level)

	count = tonumber(ARP_RaidEntrys())

	for n = 1, math.floor(count + 1) , 1 do 

		local info = UIDropDownMenu_CreateInfo()
		
		info.text = n
		info.value = n
		info.func = self.onClick
		info.arg1 = n
		info.arg2 = n
		UIDropDownMenu_AddButton(info, level)
		
	end
	
end

RaidIDDropDown.onLoad = function(self, arg1, arg2, checked)
	UIDropDownMenu_SetText("1")
end

	ARP_Content3.RaidDate = ARP_Content3:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
	ARP_Content3.RaidDate:SetPoint("LEFT", ARP_Content3.RaidID, "LEFT", 0, -30);
	ARP_Content3.RaidDate:SetTextColor(1, 1, 0)
	ARP_Content3.RaidDate:SetText(ARP_RAIDDATE)

	ARP_Content3.EditRaidDate = CreateFrame("EditBox", nil, ARP_Content3, "InputBoxTemplate")
	ARP_Content3.EditRaidDate:SetPoint("LEFT", ARP_Content3.RaidDate, 100, 0);
	ARP_Content3.EditRaidDate:SetWidth(65)
	ARP_Content3.EditRaidDate:SetHeight(50)
	ARP_Content3.EditRaidDate:SetAutoFocus(false)
	ARP_Content3.EditRaidDate:Insert(string.sub(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][2], 1 , 8))
	ARP_Content3.EditRaidDate:SetMaxLetters(8)
	ARP_Content3.EditRaidDate:Show()

	ARP_Content3.RaidTime = ARP_Content3:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
	ARP_Content3.RaidTime:SetPoint("LEFT", ARP_Content3.RaidDate, "LEFT", 175, 0);
	ARP_Content3.RaidTime:SetTextColor(1, 1, 0)
	ARP_Content3.RaidTime:SetText(ARP_RAIDTIME)

local RaidTimeHourDropDown = CreateFrame("frame", "RaidTimeHourDropDown", ARP_Content3, "UIDropDownMenuTemplate")
	RaidTimeHourDropDown:SetPoint("LEFT", ARP_Content3.RaidTime, 75, 0);
	UIDropDownMenu_SetText(RaidTimeHourDropDown, string.sub(AchchazusRaidplanerDB[1][2] , 9, 11))
	UIDropDownMenu_SetWidth(RaidTimeHourDropDown, 50) 

RaidTimeHourDropDown.onClick = function(self, arg1, arg2, checked)
	UIDropDownMenu_SetText(RaidTimeHourDropDown, arg2)
	CloseDropDownMenus()
end

RaidTimeHourDropDown.initialize = function(self, level)

	count = 0

	for key, value in pairs(ARP_DROPRAIDHOUR) do 

		local info = UIDropDownMenu_CreateInfo()
		
		info.text = value
		info.value = count
		info.func = self.onClick
		info.arg1 = key
		info.arg2 = value
		UIDropDownMenu_AddButton(info, level)
		
		count = count + 1
	end
	
end

local RaidTimeMinDropDown = CreateFrame("frame", "RaidTimeMinDropDown", ARP_Content3, "UIDropDownMenuTemplate")
	RaidTimeMinDropDown:SetPoint("LEFT", ARP_Content3.RaidTime, 150, 0);
	UIDropDownMenu_SetText(RaidTimeMinDropDown, string.sub(AchchazusRaidplanerDB[1][2] , 13, 14))
	UIDropDownMenu_SetWidth(RaidTimeMinDropDown, 50) 

RaidTimeMinDropDown.onClick = function(self, arg1, arg2, checked)
	UIDropDownMenu_SetText(RaidTimeMinDropDown, arg2)
	CloseDropDownMenus()
end

RaidTimeMinDropDown.initialize = function(self, level)

	count = 0

	for key, value in pairs(ARP_DROPRAIDMIN) do 

		local info = UIDropDownMenu_CreateInfo()
		
		info.text = value
		info.value = count
		info.func = self.onClick
		info.arg1 = key
		info.arg2 = value
		UIDropDownMenu_AddButton(info, level)
		
		count = count + 1
	end
	
end

	ARP_Content3.RaidName = ARP_Content3:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
	ARP_Content3.RaidName:SetPoint("LEFT", ARP_Content3.RaidDate, "LEFT", 0, -30);
	ARP_Content3.RaidName:SetTextColor(1, 1, 0)
	ARP_Content3.RaidName:SetText(ARP_RAIDNAME)

local RaidNameDropDown = CreateFrame("frame", "RaidNameDropDown", ARP_Content3, "UIDropDownMenuTemplate")
RaidNameDropDown:SetPoint("LEFT", ARP_Content3.RaidName, 75, 0);
UIDropDownMenu_SetText(RaidNameDropDown, AchchazusRaidplanerDB[1][1])


RaidNameDropDown.onClick = function(self, arg1, arg2, checked)
	UIDropDownMenu_SetText(RaidNameDropDown, arg2)
	CloseDropDownMenus()
end

RaidNameDropDown.initialize = function(self, level)

	count = 0

	for key, value in pairs(ARP_DROPRAIDNAME) do 

		local info = UIDropDownMenu_CreateInfo()
		
		info.text = value
		info.value = count
		info.func = self.onClick
		info.arg1 = key
		info.arg2 = value
		UIDropDownMenu_AddButton(info, level)
		
		count = count + 1
	end
	
end

	ARP_Content3.PlayerName = ARP_Content3:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
	ARP_Content3.PlayerName:SetPoint("LEFT", ARP_Content3.RaidName, "LEFT", 0, -75);
	ARP_Content3.PlayerName:SetTextColor(1, 1, 0)
	ARP_Content3.PlayerName:SetText(ARP_PLAYERNAME)

	ARP_Content3.EditPlayerName = CreateFrame("EditBox", nil, ARP_Content3, "InputBoxTemplate")
	ARP_Content3.EditPlayerName:SetPoint("LEFT", RaidNameDropDown, "LEFT", 25, -75);
	ARP_Content3.EditPlayerName:SetWidth(100)
	ARP_Content3.EditPlayerName:SetHeight(50)
	ARP_Content3.EditPlayerName:SetAutoFocus(false)
	ARP_Content3.EditPlayerName:SetMaxLetters(25)
	ARP_Content3.EditPlayerName:Show()

	ARP_Content3.PlayerClass = ARP_Content3:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
	ARP_Content3.PlayerClass:SetPoint("LEFT", ARP_Content3.PlayerName, "LEFT", 0, -25);
	ARP_Content3.PlayerClass:SetTextColor(1, 1, 0)
	ARP_Content3.PlayerClass:SetText(ARP_PLAYERCLASS)

local PlayerClassDropDown = CreateFrame("frame", "PlayerClassDropDown", ARP_Content3, "UIDropDownMenuTemplate")
PlayerClassDropDown:SetPoint("CENTER", ARP_Content3.EditPlayerName, "CENTER", -55, -25);

PlayerClassDropDown.onClick = function(self, arg1, arg2, checked)
	AchchazusRaidplanerDBlocal.SelectedClass = arg1
	UIDropDownMenu_SetText(PlayerClassDropDown, arg2)
	CloseDropDownMenus()
end

PlayerClassDropDown.initialize = function(self, level)

	count = 0

	for key, value in pairs(AchchazusRaidplanerDBclass) do 
		if key ~= "cA" then
			local info = UIDropDownMenu_CreateInfo()
		
			info.text = AchchazusRaidplanerDBclass[key]["realname"]
			info.value = count
			info.func = self.onClick
			info.arg1 = AchchazusRaidplanerDBclass[key]["name"]
			info.arg2 = AchchazusRaidplanerDBclass[key]["realname"]
			UIDropDownMenu_AddButton(info, level)
		
			count = count + 1
		end
	end
	
end

	ARP_Content3.UpdatePlayer = CreateFrame("Button", nil, ARP_Content3, "GameMenuButtonTemplate");
	ARP_Content3.UpdatePlayer:SetPoint("CENTER", ARP_Content3.PlayerClass, "CENTER", 50, -50);
	ARP_Content3.UpdatePlayer:SetSize(180, 30);
	ARP_Content3.UpdatePlayer:SetText(ARP_ADDPLAYER);
	ARP_Content3.UpdatePlayer:SetNormalFontObject("GameFontNormalLarge");
	ARP_Content3.UpdatePlayer:SetHighlightFontObject("GameFontHighlightLarge");
ARP_Content3.UpdatePlayer:SetScript("OnClick", function()

ARP_PlayShowButtons()

guildName, guildRankName, guildRankIndex = GetGuildInfo("player");

if not playerName == "Renegade" then
	if tonumber(guildRankIndex) > 1 then
	print(ARP_NO_RAIDLEADER)
	return end
end

local RaidID = tonumber(UIDropDownMenu_GetText(RaidIDDropDown))

if UIDropDownMenu_GetText(RaidIDDropDown) == nil then
	print(ARP_NOID)
	return
end

if ARP_Content3.EditPlayerName:GetNumLetters() < 1 then
	print(ARP_NONAME)
	return
end

if UIDropDownMenu_GetText(PlayerClassDropDown) == nil then
	print(ARP_NOCLASS)
	return
end

local count = 0
for value in pairs(AchchazusRaidplanerDB[RaidID]) do 
	if AchchazusRaidplanerDB[RaidID][math.floor(count+1)] ~= nil then
		count = count + 1
	end
AchchazusRaidplanerDBlocal.counterRegistration = count
end	

AchchazusRaidplanerDBlocal.RegistrationClass = string.upper(AchchazusRaidplanerDBlocal.SelectedClass)
AchchazusRaidplanerDBlocal.Anmeldung = tostring(ARP_Content3.EditPlayerName:GetText())

for key, value in pairs(AchchazusRaidplanerDBclass) do 

if AchchazusRaidplanerDBlocal.RegistrationClass == string.upper(AchchazusRaidplanerDBclass[key]["name"]) then

for i = AchchazusRaidplanerDBlocal.counterRegistration, 1, -1 do
	if AchchazusRaidplanerDB[RaidID][i] == AchchazusRaidplanerDBlocal.Anmeldung .. ".f." .. key or AchchazusRaidplanerDB[RaidID][i] == AchchazusRaidplanerDBlocal.Anmeldung .. ".t." .. key then 
		print(AchchazusRaidplanerDBlocal.Anmeldung..ARP_TORAIDID..RaidID..ARP_REMOVED)
		AchchazusRaidplanerDB[RaidID][i] = AchchazusRaidplanerDBlocal.Anmeldung .. ".f." .. key
		AchchazusRaidplanerDB[RaidID][i] = nil
		if AchchazusRaidplanerDB[RaidID][math.floor(i+1)] ~= nil then
			for m = i, AchchazusRaidplanerDBlocal.counterRegistration, 1 do
				AchchazusRaidplanerDB[RaidID][m] = AchchazusRaidplanerDB[RaidID][math.floor(m+1)]
				AchchazusRaidplanerDB[RaidID][math.floor(m+1)] = nil
			end
		end
		for n = 1, 79, 1 do
		if ARP_Content2["Registered"..n]:GetText() == AchchazusRaidplanerDBlocal.Anmeldung then
			ARP_Content2["Registered"..n]:SetText("Test")
		end
		if ARP_Content2["Confirmed"..n]:GetText() == AchchazusRaidplanerDBlocal.Anmeldung then
			ARP_Content2["Confirmed"..n]:SetText("Test")
		end
		end
		ARP_SendMessage()
		ARP_UpdateUI()
		return 
	end
end

for i = 1, math.floor(AchchazusRaidplanerDBlocal.counterRegistration+1), 1 do
	if AchchazusRaidplanerDB[RaidID][i] == 0 or AchchazusRaidplanerDB[RaidID][i] == nil then 
		print(AchchazusRaidplanerDBlocal.Anmeldung..ARP_TORAIDID..RaidID..ARP_ADDED)
		AchchazusRaidplanerDB[RaidID][i] = AchchazusRaidplanerDBlocal.Anmeldung .. ".f." .. key
		ARP_SendMessage()
		ARP_UpdateUI()
		return
	end
end
end
end


end)


	ARP_Content3.UpdateRaid = CreateFrame("Button", nil, ARP_Content3, "GameMenuButtonTemplate");
	ARP_Content3.UpdateRaid:SetPoint("CENTER", ARP_Content3, "CENTER", 0, 0);
	ARP_Content3.UpdateRaid:SetSize(120, 30);
	ARP_Content3.UpdateRaid:SetText(ARP_UPDATE_RAID);
	ARP_Content3.UpdateRaid:SetNormalFontObject("GameFontNormalLarge");
	ARP_Content3.UpdateRaid:SetHighlightFontObject("GameFontHighlightLarge");
ARP_Content3.UpdateRaid:SetScript("OnClick", function()

ARP_PlayShowButtons()

guildName, guildRankName, guildRankIndex = GetGuildInfo("player");


if not playerName == "Renegade" then
	if tonumber(guildRankIndex) > 1 then
	print(ARP_NO_RAIDLEADER)
	return end
end

local DateEntry = ARP_Content3.EditRaidDate:GetText()

local dd = tostring(string.sub(DateEntry, 1, 2))
local mm = tostring(string.sub(DateEntry, 4, 5))
local yy = tostring(string.sub(DateEntry, 7, 8))

if  strmatch(dd,"%d", 1) == nil or strmatch(dd,"%d", 2) == nil or strmatch(mm,"%d" , 1) == nil or strmatch(mm,"%d" , 2) == nil or strmatch(yy,"%d" , 1) == nil or strmatch(yy,"%d" , 2) == nil or tonumber(dd) > 31 or tonumber(mm) > 12 then
	
	print(ARP_FALSEDATE)

	return
end

count = tonumber(ARP_RaidEntrys())

for entrys in pairs(AchchazusRaidplanerDB) do
	for key, value in pairs(AchchazusRaidplanerDB[entrys]) do
		if math.floor(count+1) == tonumber(UIDropDownMenu_GetText(RaidIDDropDown)) then
			AchchazusRaidplanerDB[math.floor(count+1)] = {}
			AchchazusRaidplanerDB[math.floor(count+1)][1] = tostring(UIDropDownMenu_GetText(RaidNameDropDown))
			AchchazusRaidplanerDB[math.floor(count+1)][2] = ARP_Content3.EditRaidDate:GetText().." "..tostring(UIDropDownMenu_GetText(RaidTimeHourDropDown))..":"..tostring(UIDropDownMenu_GetText(RaidTimeMinDropDown))
			ARP_SendMessage()
			ARP_UpdateUI()
			return
		end
		if entrys == tonumber(UIDropDownMenu_GetText(RaidIDDropDown)) then
			if key == 1 then
			AchchazusRaidplanerDB[entrys][key] = tostring(UIDropDownMenu_GetText(RaidNameDropDown))
			end
			if key == 2 then
			AchchazusRaidplanerDB[entrys][key] = ARP_Content3.EditRaidDate:GetText().." "..tostring(UIDropDownMenu_GetText(RaidTimeHourDropDown))..":"..tostring(UIDropDownMenu_GetText(RaidTimeMinDropDown))
			ARP_SendMessage()
			ARP_UpdateUI()
			return
			end
		end
	end
end
end)

	ARP_Content3.DeleteRaid = CreateFrame("Button", nil, ARP_Content3, "GameMenuButtonTemplate");
	ARP_Content3.DeleteRaid:SetPoint("CENTER", ARP_Content3.UpdateRaid, "CENTER", 0, -75);
	ARP_Content3.DeleteRaid:SetSize(120, 30);
	ARP_Content3.DeleteRaid:SetText(ARP_DELETE_RAID);
	ARP_Content3.DeleteRaid:SetNormalFontObject("GameFontNormalLarge");
	ARP_Content3.DeleteRaid:SetHighlightFontObject("GameFontHighlightLarge");
ARP_Content3.DeleteRaid:SetScript("OnClick", function()

ARP_PlayShowButtons()

guildName, guildRankName, guildRankIndex = GetGuildInfo("player");

if not playerName == "Renegade" then
	if tonumber(guildRankIndex) > 1 then
	print(ARP_NO_RAIDLEADER)
	return end
end

StaticPopup_Show ("CONFORM_DELETE")

end)


local function DeleteRaid()

count = tonumber(ARP_RaidEntrys())

for entrys in pairs(AchchazusRaidplanerDB) do
	if entrys == tonumber(UIDropDownMenu_GetText(RaidIDDropDown)) then
		if count == 1 then
		return
		end
		if next (AchchazusRaidplanerDB[tonumber(UIDropDownMenu_GetText(RaidIDDropDown))]) ~= nil then
			table.remove(AchchazusRaidplanerDB, tonumber(UIDropDownMenu_GetText(RaidIDDropDown)))
		end
	end
end

for i = 1, count, 1 do
	if ARP_Content3["RegisteredRaids"..i]:GetText() ~= "Test" then
		ARP_Content3["RegisteredRaids"..i]:SetText("Test")
		ARP_Content3["RegisteredRaids"..i]:Hide()
	end
end

if AchchazusRaidplanerDBlocal.Page == tonumber(UIDropDownMenu_GetText(RaidIDDropDown)) then
	AchchazusRaidplanerDBlocal.Page = AchchazusRaidplanerDBlocal.Page - 1
end

ARP_SendMessage()
ARP_UpdateUI()

end

	ARP_Content3.RegisteredRaids = ARP_Content3:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
	ARP_Content3.RegisteredRaids:SetPoint("CENTER", ARP_Content3, "CENTER", 200, 125);
	ARP_Content3.RegisteredRaids:SetTextColor(1, 1, 0)
	ARP_Content3.RegisteredRaids:SetText("")

	ARP_Content3.RegisteredRaidsMenu = CreateFrame('Frame', "RegisteredRaidsMenu", ARP_Content3, "OptionsBoxTemplate")
	ARP_Content3.RegisteredRaidsMenu:SetPoint("CENTER", ARP_Content3.RegisteredRaids, "CENTER", 0, -150)
	ARP_Content3.RegisteredRaidsMenu:SetWidth( 150 )
	ARP_Content3.RegisteredRaidsMenu:SetHeight( 270 )

	ARP_Content3.RegisteredRaidsScrollFrame = CreateFrame("ScrollFrame", nil, ARP_Content3.RegisteredRaidsMenu, "UIPanelScrollFrameTemplate");
	ARP_Content3.RegisteredRaidsScrollFrame:SetPoint("TOPLEFT", ARP_Content3.RegisteredRaidsMenu, "TOPLEFT", 4, -8);
	ARP_Content3.RegisteredRaidsScrollFrame:SetPoint("BOTTOMRIGHT", ARP_Content3.RegisteredRaidsMenu, "BOTTOMRIGHT", -3, 4);
	ARP_Content3.RegisteredRaidsScrollFrame:SetClipsChildren(true);

	ARP_Content3.RegisteredRaidsScrollFrame.ScrollBar:ClearAllPoints();
	ARP_Content3.RegisteredRaidsScrollFrame.ScrollBar:SetPoint("TOPLEFT", ARP_Content3.RegisteredRaidsScrollFrame, "TOPRIGHT", -12, -35);
	ARP_Content3.RegisteredRaidsScrollFrame.ScrollBar:SetPoint("BOTTOMRIGHT", ARP_Content3.RegisteredRaidsScrollFrame, "BOTTOMRIGHT", -7, 18);

local count = 0
childsize = 0

for  i = 1, 15, 1 do 
	count = count + 1
end

local child = CreateFrame("Frame", nil, ARP_Content3.RegisteredRaidsScrollFrame);
child:SetSize(150, math.floor(110+count*15))

ARP_Content3.RegisteredRaidsScrollFrame:SetScrollChild(child)

	ARP_Content3.RegisteredRaidsText = ARP_Content3:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
	ARP_Content3.RegisteredRaidsText:SetPoint("TOP", child, "TOP", 0, -3);
	ARP_Content3.RegisteredRaidsText:SetTextColor(1, 0.96, 0.41)
	ARP_Content3.RegisteredRaidsText:SetText(ARP_REGISTERED_RAID)

local count = 0
local a = -20
local length = 0

for  i = 1, 15, 1 do 
	ARP_Content3["RegisteredRaids"..i] = CreateFrame("Button", "RegisteredRaids"..i, ARP_Content3.RegisteredRaidsScrollFrame, "UIPanelButtonTemplate");
	ARP_Content3["RegisteredRaids"..i]:SetPoint("TOP", ARP_Content3.RegisteredRaidsText, "TOP", -10, math.floor(a*i));
	ARP_Content3["RegisteredRaids"..i]:SetText("Test")
	ARP_Content3["RegisteredRaids"..i]:SetSize(100, 15);
	ARP_Content3["RegisteredRaids"..i]:Hide()
ARP_Content3["RegisteredRaids"..i]:SetScript("OnClick", function()
	UIDropDownMenu_SetText(RaidNameDropDown, AchchazusRaidplanerDB[i][1])
	ARP_Content3.EditRaidDate:SetText(string.sub(AchchazusRaidplanerDB[i][2], 1 , 8))
	UIDropDownMenu_SetText(RaidIDDropDown, i )
	UIDropDownMenu_SetText(RaidTimeHourDropDown, string.sub(AchchazusRaidplanerDB[i][2] , 9, 11))
	UIDropDownMenu_SetText(RaidTimeMinDropDown, string.sub(AchchazusRaidplanerDB[i][2] , 13, 14))
	ARP_UpdateUI()	
	end	)	
end

for  i = 1, 15, 1 do 

	if AchchazusRaidplanerDB[i] == table then
		ARP_Content3["RegisteredRaids"..i]:SetText("ID"..i .. ": " .. AchchazusRaidplanerDB[i][1])
		ARP_Content3["RegisteredRaids"..i]:Show()
	end
	
end

	ARP_Content1.BackButton = CreateFrame("Button", nil, ARP_Content1, "GameMenuButtonTemplate");
	ARP_Content1.BackButton:SetPoint("TOPRIGHT", ARP_Content1, "TOPRIGHT", -25, -25);
	ARP_Content1.BackButton:SetSize(100, 30);
	ARP_Content1.BackButton:SetNormalFontObject("GameFontNormalLarge");
	ARP_Content1.BackButton:SetHighlightFontObject("GameFontHighlightLarge");
	ARP_Content1.BackButton:SetText(ARP_BACK)
	
ARP_Content1.BackButton:SetScript("OnClick", function()		

	ARP_PlayShowButtons()
	
	AchchazusRaidplanerDBlocal.InCalender = true
	
	ARP_UpdateUI()

end )

	ARP_Content1.MonthBack = CreateFrame("Button", nil, ARP_Content1, "UIPanelButtonTemplate");
	ARP_Content1.MonthBack:SetPoint("TOPLEFT", ARP_Content1, "TOPLEFT", 200, -40);
	ARP_Content1.MonthBack:SetText("<")
	ARP_Content1.MonthBack:SetNormalFontObject("GameFontNormalLarge");
	ARP_Content1.MonthBack:SetHighlightFontObject("GameFontHighlightLarge");
	
ARP_Content1.MonthBack:SetScript("OnClick", function()

ARP_PlayChanceSound()

if AchchazusRaidplanerDBlocal.ShowMonth ~= 0 then
AchchazusRaidplanerDBlocal.ShowMonth = AchchazusRaidplanerDBlocal.ShowMonth - 1
	if AchchazusRaidplanerDBlocal.ShowMonth == 0 then
		AchchazusRaidplanerDBlocal.ShowMonth = 12
		AchchazusRaidplanerDBlocal.Year = AchchazusRaidplanerDBlocal.Year - 1
	end
end


ARP_UpdateUI()

end )

	ARP_Content1.MonthForrward = CreateFrame("Button", nil, ARP_Content1, "UIPanelButtonTemplate");
	ARP_Content1.MonthForrward:SetPoint("TOPRIGHT", ARP_Content1, "TOPRIGHT", -175, -40);
	ARP_Content1.MonthForrward:SetText(">")
	ARP_Content1.MonthForrward:SetNormalFontObject("GameFontNormalLarge");
	ARP_Content1.MonthForrward:SetHighlightFontObject("GameFontHighlightLarge");
	
ARP_Content1.MonthForrward:SetScript("OnClick", function()

ARP_PlayChanceSound()

if AchchazusRaidplanerDBlocal.ShowMonth ~= 13 then
AchchazusRaidplanerDBlocal.ShowMonth = AchchazusRaidplanerDBlocal.ShowMonth + 1
	if AchchazusRaidplanerDBlocal.ShowMonth == 13 then
		AchchazusRaidplanerDBlocal.ShowMonth = 1
		AchchazusRaidplanerDBlocal.Year = AchchazusRaidplanerDBlocal.Year + 1
	end
end

ARP_UpdateUI()

end )

	ARP_Content1.MonthText = ARP_Content1:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge");
	ARP_Content1.MonthText:SetPoint("TOP", ARP_Content1, 0, -40);
	ARP_Content1.MonthText:SetText("")

local PosX = 200
local PosY = -75

for n = 1, 40, 1 do

if n == 8 then PosX = 200 PosY = -140 end
if n == 15 then PosX = 200 PosY = -205 end
if n == 22 then PosX = 200 PosY = -270 end
if n == 29 then PosX = 200 PosY = -335 end
if n == 36 then PosX = 200 PosY = -400 end

	ARP_Content1["DayFrame"..n] = CreateFrame("FRAME",nil, ARP_Content1, "OptionsBoxTemplate")
	ARP_Content1["DayFrame"..n]:SetSize(65, 65);
	ARP_Content1["DayFrame"..n]:SetPoint("TOPLEFT", ARP_Content1, "TOPLEFT", PosX, PosY)
	ARP_Content1["DayFrame"..n]:Hide()
	ARP_Content1["DayFrame"..n]:EnableMouse(true)
ARP_Content1["DayFrame"..n]:SetScript("OnMouseDown", function(self,...)

	if ARP_Content1["DayEventText"..n]:GetText() ~= nil then
	
	dd = tonumber(ARP_Content1["DayNummer"..n]:GetText())
	
	if string.len(dd) == 1 then
		dd = "0"..dd
	end
	
	mm = tonumber(AchchazusRaidplanerDBlocal.ShowMonth)
	
	if string.len(mm) == 1 then
		mm = "0"..mm
	end
	
	yy = tonumber(string.sub(AchchazusRaidplanerDBlocal.Year, 3))
	
	count = tonumber(ARP_RaidEntrys())
	
	for i = 1, count, 1 do
	
		for key, value in pairs(AchchazusRaidplanerDB[i]) do
		
			if string.match(AchchazusRaidplanerDB[i][2], dd.."."..mm.."."..yy) then
				
				ARP_PlayShowButtons()
				
				AchchazusRaidplanerDBlocal.Page = i
				AchchazusRaidplanerDBlocal.InCalender = false
		
				ARP_UpdateUI()
				
				break
				
			else
			
				break
		
			end
		end
	end
	
	end
	
end )

    ARP_Content1["BossPreview"..n] = CreateFrame('PlayerModel', "BossPreview", ARP_Content1)
	ARP_Content1["BossPreview"..n]:SetPoint("CENTER", ARP_Content1["DayFrame"..n], "CENTER", -10, -10)
	ARP_Content1["BossPreview"..n]:SetWidth( 40 )
	ARP_Content1["BossPreview"..n]:SetHeight( 40 )
	ARP_Content1["BossPreview"..n]:SetRotation(0)
	ARP_Content1["BossPreview"..n]:SetFrameLevel(9)
	ARP_Content1["BossPreview"..n]:SetCamera(1)
	ARP_Content1["BossPreview"..n]:Hide()
	ARP_Content1["BossPreview"..n]:ClearModel()
	ARP_Content1["BossPreview"..n]:SetSequence(0)


    ARP_Content1["TodayDayFrame"..n] = CreateFrame("FRAME",nil, ARP_Content1, "ThinBorderTemplate")
	ARP_Content1["TodayDayFrame"..n]:SetSize(66, 66);
	ARP_Content1["TodayDayFrame"..n]:SetPoint("TOPLEFT", ARP_Content1, "TOPLEFT", PosX, PosY)
	ARP_Content1["TodayDayFrame"..n]:Hide()

    ARP_Content1["DayText"..n] = ARP_Content1:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
	ARP_Content1["DayText"..n]:SetPoint("TOPLEFT", ARP_Content1["DayFrame"..n], 4, -4);
	ARP_Content1["DayText"..n]:SetTextColor(1, 0.96 , 0.41) -- (1, 0.96 , 0.41)
	ARP_Content1["DayText"..n]:SetText("")

    ARP_Content1["DayEventText"..n] = ARP_Content1:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
	ARP_Content1["DayEventText"..n]:SetPoint("TOPRIGHT", ARP_Content1["DayFrame"..n], "TOPRIGHT", -4, -4);
	ARP_Content1["DayEventText"..n]:SetTextColor(1, 0.96 , 0.41)
	ARP_Content1["DayEventText"..n]:SetText("")

	ARP_Content1["DayNummer"..n] = ARP_Content1:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
	ARP_Content1["DayNummer"..n]:SetPoint("BOTTOMRIGHT", ARP_Content1["DayFrame"..n], -4, 4);
	ARP_Content1["DayNummer"..n]:SetTextColor(1, 0.96 , 0.41) -- (1, 0.96 , 0.41)
	ARP_Content1["DayNummer"..n]:SetText("")

PosX = PosX + 65

end

local numInstances = GetNumSavedInstances()
local NumbersRaidIDs = 0

ARP_Content1.ResetText = ARP_Content1:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
ARP_Content1.ResetText:SetPoint("TOPLEFT", ARP_Content1, "TOPLEFT", 80, -80);
ARP_Content1.ResetText:SetTextColor(1, 0.96 , 0.41)
ARP_Content1.ResetText:SetText("ID´s")

local PosY = -25

for i = 1, numInstances , 1 do
	
	local name, id, reset, difficulty, locked, extended, instanceIDMostSig, isRaid, maxPlayers, difficultyName, numEncounters, encounterProgress = GetSavedInstanceInfo(i)
	
		if name ~= nil then
		
		
		ARP_Content1["ID"..i] = ARP_Content1:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
		ARP_Content1["ID"..i]:SetPoint("CENTER", ARP_Content1.ResetText, "CENTER", 0, PosY);
		ARP_Content1["ID"..i]:SetTextColor(1, 0.96 , 0.41)
		
		NumbersRaidIDs = NumbersRaidIDs + 1
		
		local resetmin = ARP_Round(math.abs(reset / 60) , 3)
		local resethour = ARP_Round(math.abs(resetmin / 60), 3)

		local days = 0
		local stunden = 0
		local minuten = 0
		local sekunden = 0
		
		if tonumber(resethour) > 24 then	
		
			for n = 1 ,resethour ,1 do
			
				if math.floor(resethour / 24) >= 1 then
					resethour = resethour - 24
					days = days + 1
				end
				if math.floor(resethour / 24) < 1 then
					restmin = ARP_Round(math.abs(resethour * 60), 3)
					stunden = ARP_Round(math.abs(restmin / 60), 0)
					
					if string.match(name, "Kern") then
						name = "MC"
					end
					ARP_Content1["ID"..i]:SetText(name.." : "..days.." d "..stunden.." h ".."("..encounterProgress.."/"..numEncounters..")")
					PosY = PosY - 25
					break
				end
			end
		end	
		
		if tonumber(resethour) < 24 then

			for n = 1 , tonumber(resethour) ,1 do
			
				if tonumber(resethour) >= 1 then
					resethour = resethour - 1
					stunden  = stunden + 1
				end
				if tonumber(resethour) < 1 then
					minuten = ARP_Round(math.abs(resethour * 60), 0)
					if string.match(name, "Kern") then
						name = "MC"
					end
					ARP_Content1["ID"..i]:SetText(name.." : "..stunden.." h "..minuten.." m ".."("..encounterProgress.."/"..numEncounters..")")
					PosY = PosY - 25
					break
				end
			end
		end
	end
end

ARP_Content1.OutDatedText = ARP_Content1:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
ARP_Content1.OutDatedText:SetPoint("CENTER", ARP_Content1.RegistrationButton, "CENTER", 0, -25);
ARP_Content1.OutDatedText:SetTextColor(1, 0, 0)
ARP_Content1.OutDatedText:SetText(ARP_NEWVERSION)
ARP_Content1.OutDatedText:Hide()


VersionCheck = CreateFrame("Frame", "Achchazu VersionCheckMemberframe", UIParent, "BasicFrameTemplateWithInset");

VersionCheck:Hide()
VersionCheck:SetMovable(true)
VersionCheck:SetUserPlaced(isUserPlaced);
VersionCheck:EnableMouse(true)
VersionCheck:RegisterForDrag("LeftButton")
VersionCheck:SetScript("OnDragStart", VersionCheck.StartMoving)
VersionCheck:SetScript("OnDragStop", VersionCheck.StopMovingOrSizing)
VersionCheck:SetSize(400, 400);
VersionCheck:SetFrameLevel(10)
VersionCheck:SetPoint("CENTER", UIParent, "CENTER")


VersionCheck.title = VersionCheck:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
VersionCheck.title:SetPoint("LEFT", VersionCheck.TitleBg, "LEFT", 5, 0);
VersionCheck.title:SetText("Versionscheck "..ARP_VERSION);

VersionCheck.title2 = VersionCheck:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
VersionCheck.title2:SetPoint("RIGHT", VersionCheck.TitleBg, "RIGHT", -5, 0);
VersionCheck.title2:SetText("from Renegade@Lucifron");

VersionCheck.ScrollFrame = CreateFrame("ScrollFrame", nil, VersionCheck, "UIPanelScrollFrameTemplate");
VersionCheck.ScrollFrame:SetPoint("TOPLEFT", VersionCheck, "TOPLEFT", 4, -8);
VersionCheck.ScrollFrame:SetPoint("BOTTOMRIGHT", VersionCheck, "BOTTOMRIGHT", -3, 4);
VersionCheck.ScrollFrame:SetClipsChildren(true);
VersionCheck.ScrollFrame:SetScript("OnMouseWheel", ScrollFrame_OnMouseWheel);

VersionCheck.ScrollFrame.ScrollBar:ClearAllPoints();
VersionCheck.ScrollFrame.ScrollBar:SetPoint("TOPLEFT", VersionCheck.ScrollFrame, "TOPRIGHT", -12, -35);
VersionCheck.ScrollFrame.ScrollBar:SetPoint("BOTTOMRIGHT", VersionCheck.ScrollFrame, "BOTTOMRIGHT", -7, 18);

local child = CreateFrame("Frame", nil, VersionCheck.ScrollFrame);
child:SetSize(400, 400)

VersionCheck.ScrollFrame:SetScrollChild(child)

VersionCheck.PlayerText = VersionCheck:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
VersionCheck.PlayerText:SetPoint("TOPLEFT", child, 90, -40);
VersionCheck.PlayerText:SetText("Player")

VersionCheck.VersionText = VersionCheck:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
VersionCheck.VersionText:SetPoint("TOPRIGHT", child, -90, -40);
VersionCheck.VersionText:SetText("Version")

	ARP_Content3.VersionCheckMember = CreateFrame("Button", nil, ARP_Content3, "GameMenuButtonTemplate");
	ARP_Content3.VersionCheckMember:SetPoint("CENTER", ARP_Content3.DeleteRaid, "CENTER", 0, -75);
	ARP_Content3.VersionCheckMember:SetSize(120, 30);
	ARP_Content3.VersionCheckMember:SetText(ARP_CHECKVERSION);
	ARP_Content3.VersionCheckMember:SetNormalFontObject("GameFontNormalLarge");
	ARP_Content3.VersionCheckMember:SetHighlightFontObject("GameFontHighlightLarge");
	
ARP_Content3.VersionCheckMember:SetScript("OnClick", function()

ARP_PlayShowButtons()

guildName, guildRankName, guildRankIndex = GetGuildInfo("player");

if not playerName == "Renegade" then
	if tonumber(guildRankIndex) > 1 then
	print(ARP_NO_RAIDLEADER)
	return end
end

if not VersionCheck:IsShown() then
		VersionCheck:Show()
		ARP_PlayShowSound()
		addon:SendCommMessage("ARPVer", "VERSIONSCHECK", "GUILD", player, "BULK")
		CheckVersionMember = true
		CounterChecked = 1
		VersionCheckMember = true
	else 
		VersionCheck:Hide()
		VersionCheckMember = false
end

end )


function ARP_UpdateVersionCheckMember()

if DataCheckMemberVersion ~= nil then
count = 0

for key in pairs(DataCheckMemberVersion) do 
	count = count + 1
end



a = -25

for n = 1 , count , 1 do

if VersionCheck["PlayerNameText"..n] ~= nil then
	VersionCheck["PlayerNameText"..n]:SetText("")
	VersionCheck["PlayerVersionText"..n]:SetText("")
end

length = string.len(DataCheckMemberVersion[n])

VersionCheck["PlayerNameText"..n] = VersionCheck:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
VersionCheck["PlayerNameText"..n]:SetPoint("TOP", VersionCheck.PlayerText, 0 , a);
VersionCheck["PlayerNameText"..n]:SetText(string.sub(DataCheckMemberVersion[n], 1, math.floor(length - 4)))

VersionCheck["PlayerVersionText"..n] = VersionCheck:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
VersionCheck["PlayerVersionText"..n]:SetPoint("TOP", VersionCheck.VersionText, 0 , a);
VersionCheck["PlayerVersionText"..n]:SetText(string.sub(DataCheckMemberVersion[n], math.floor(length - 2)))

if tonumber(string.sub(DataCheckMemberVersion[n], math.floor(length - 2))) < tonumber(ARP_VERSION_CHECK) then
VersionCheck["PlayerNameText"..n]:SetTextColor( 1, 1 ,0 )
VersionCheck["PlayerVersionText"..n]:SetTextColor( 1, 1 ,0 )
end
if tonumber(string.sub(DataCheckMemberVersion[n], math.floor(length - 2))) < math.floor(tonumber(ARP_VERSION_CHECK) - 3) then
VersionCheck["PlayerNameText"..n]:SetTextColor( 1, 0 ,0 )
VersionCheck["PlayerVersionText"..n]:SetTextColor( 1, 0 ,0 )
end
if tonumber(string.sub(DataCheckMemberVersion[n], math.floor(length - 2))) == tonumber(ARP_VERSION_CHECK) then
VersionCheck["PlayerNameText"..n]:SetTextColor( 0, 1 ,0 )
VersionCheck["PlayerVersionText"..n]:SetTextColor( 0, 1 ,0 )
end

a = a - 20

end

end

end
	
function ARP_UpdateUI()

ClearAllARP_Content1()

if AchchazusRaidplanerDBlocal.InCalender == true then     -- ARP_Content 1 - Calender

ARP_Content1.MonthForrward:Show()
ARP_Content1.MonthBack:Show()
ARP_Content1.ResetText:Show()

if tonumber(NumbersRaidIDs) > 0 then
	for i = 1, tonumber(NumbersRaidIDs), 1 do
		ARP_Content1["ID"..i]:Show()
		ARP_Content1.ResetText:Show()
	end
end

if outdatet == true then
	ARP_Content1.OutDatedText:Show()
end


if tonumber(AchchazusRaidplanerDBlocal.Year) == tonumber(date("%Y")) then
	if tonumber(AchchazusRaidplanerDBlocal.ShowMonth) == math.floor(date("%m") - 1) then
		ARP_Content1.MonthBack:Disable()
	else
		ARP_Content1.MonthBack:Enable()
	end

	if tonumber(AchchazusRaidplanerDBlocal.ShowMonth) == math.floor(date("%m") + 3) then
		ARP_Content1.MonthForrward:Disable()
	else
		ARP_Content1.MonthForrward:Enable()
	end
end

if tonumber(AchchazusRaidplanerDBlocal.Year) ~= tonumber(date("%Y")) then
	
local YearChange = 1
	
	if tonumber(date("%m")) == 10 then
		YearChange = 1
	elseif tonumber(date("%m")) == 11 then
		YearChange = 2
	elseif tonumber(date("%m")) == 12 then	
		YearChange = 3
	end
	
	if tonumber(AchchazusRaidplanerDBlocal.ShowMonth) == YearChange then
		ARP_Content1.MonthForrward:Disable()
	else
		ARP_Content1.MonthForrward:Enable()
	end
end

ARP_Content1.MonthText:SetText(ARP_MONTH[tonumber(AchchazusRaidplanerDBlocal.ShowMonth)].." "..AchchazusRaidplanerDBlocal.Year)

NumberOfDays = ARP_GetDaysInMonth(tonumber(AchchazusRaidplanerDBlocal.ShowMonth), tonumber(AchchazusRaidplanerDBlocal.Year))

DayNumber, DayName = ARP_GetDayofWeek(1, tonumber(AchchazusRaidplanerDBlocal.ShowMonth), tonumber(AchchazusRaidplanerDBlocal.Year))

CountDay = 1

if DayNumber == 1 then
DayNumber = 8
end

for n = DayNumber-1, math.floor(NumberOfDays+DayNumber-2), 1 do

count = tonumber(ARP_RaidEntrys())

for i = 1, count, 1 do

dd = string.sub(AchchazusRaidplanerDB[i][2], 1, 2)
mm = string.sub(AchchazusRaidplanerDB[i][2], 4, 5)
yy = string.sub(AchchazusRaidplanerDB[i][2], 7, 8)

if tonumber(dd) == CountDay and tonumber(mm) == tonumber(AchchazusRaidplanerDBlocal.ShowMonth) and tonumber(yy) == tonumber(string.sub(AchchazusRaidplanerDBlocal.Year, 3)) then
	ARP_Content1["DayEventText"..n]:SetText(AchchazusRaidplanerDB[i][1])
	
	for key, value in pairs(AchchazusRaidplanerDB[i]) do
	length = string.len(AchchazusRaidplanerDB[i][key])
		if string.match(playerName, string.sub(value, 1, math.floor(length-5))) and string.match(AchchazusRaidplanerDB[i][key], "%.f") and not string.match(AchchazusRaidplanerDB[i][key], "%.cA") then
			ARP_Content1["DayFrame"..n]:SetBackdropBorderColor(1, 0.96 , 0.41);
			break
		elseif  string.match(playerName, string.sub(value, 1, math.floor(length-5))) and string.match(AchchazusRaidplanerDB[i][key], "%.t") then 
			ARP_Content1["DayFrame"..n]:SetBackdropBorderColor(0, 1, 0);
			break
		elseif	string.match(playerName, string.sub(value, 1, math.floor(length-5))) and string.match(AchchazusRaidplanerDB[i][key], "%.cA") then 
			ARP_Content1["DayFrame"..n]:SetBackdropBorderColor(0.5, 0.5, 0.5);
			break
		else
			ARP_Content1["DayFrame"..n]:SetBackdropBorderColor(1, 0, 0); 
		end
		
	end
	
end

end

if tonumber(CountDay) == tonumber(date("%d")) and tonumber(AchchazusRaidplanerDBlocal.ShowMonth) == tonumber(date("%m")) and tonumber(string.sub(AchchazusRaidplanerDBlocal.Year, 3)) == tonumber(date("%y")) then
	ARP_Content1["TodayDayFrame"..n]:Show()
end
	
ARP_Content1["DayFrame"..n]:Hide()

dw, days = ARP_GetDayofWeek(CountDay, AchchazusRaidplanerDBlocal.ShowMonth, string.sub(AchchazusRaidplanerDBlocal.Year, 3))

if AchchazusRaidplanerDBlocal.AnimationSave == true then

ARP_Content1["DayEventText"..n]:ClearAllPoints();
ARP_Content1["DayEventText"..n]:SetPoint("TOPRIGHT", ARP_Content1["DayFrame"..n], "TOPRIGHT", -4, -4);

	if ARP_Content1["DayEventText"..n]:GetText() == "MC" then
		ARP_Content1["BossPreview"..n]:SetDisplayInfo(11121)
		ARP_Content1["BossPreview"..n]:SetPosition(0, 0, -5)  
		ARP_Content1["BossPreview"..n]:SetPortraitZoom(0.6)  
		ARP_Content1["BossPreview"..n]:SetCamDistanceScale(1) 
		ARP_Content1["BossPreview"..n]:Show()
	elseif ARP_Content1["DayEventText"..n]:GetText() == "ONY" then
		ARP_Content1["BossPreview"..n]:SetDisplayInfo(8570)
		ARP_Content1["BossPreview"..n]:SetPosition(0, 0, 0)
		ARP_Content1["BossPreview"..n]:SetPortraitZoom(0.6)
		ARP_Content1["BossPreview"..n]:SetCamDistanceScale(4)
		ARP_Content1["BossPreview"..n]:Show()
	elseif ARP_Content1["DayEventText"..n]:GetText() == "BWL" then
		ARP_Content1["BossPreview"..n]:SetDisplayInfo(11380)
		ARP_Content1["BossPreview"..n]:SetPosition(0, 0, 0)
		ARP_Content1["BossPreview"..n]:SetPortraitZoom(0.6)
		ARP_Content1["BossPreview"..n]:SetCamDistanceScale(4)
		ARP_Content1["BossPreview"..n]:Show()
	elseif ARP_Content1["DayEventText"..n]:GetText() == "ZG" then
		ARP_Content1["BossPreview"..n]:SetDisplayInfo(15295)
		ARP_Content1["BossPreview"..n]:SetPosition(-2, -2, 0)
		ARP_Content1["BossPreview"..n]:SetCamera(1)
		ARP_Content1["BossPreview"..n]:SetRotation(0.9)
		ARP_Content1["BossPreview"..n]:SetPortraitZoom(1)
		ARP_Content1["BossPreview"..n]:SetCamDistanceScale(0.1)
		ARP_Content1["BossPreview"..n]:Show()
	elseif ARP_Content1["DayEventText"..n]:GetText() == "AQ20" then
		ARP_Content1["BossPreview"..n]:SetDisplayInfo(15432)
		ARP_Content1["BossPreview"..n]:SetPosition(0, 0, 0)
		ARP_Content1["BossPreview"..n]:SetCamera(1)
		ARP_Content1["BossPreview"..n]:SetRotation(0.9)
		ARP_Content1["BossPreview"..n]:SetPortraitZoom(0.6)
		ARP_Content1["BossPreview"..n]:SetCamDistanceScale(1)
		ARP_Content1["BossPreview"..n]:Show()
	elseif ARP_Content1["DayEventText"..n]:GetText() == "AQ40" then
		ARP_Content1["BossPreview"..n]:SetDisplayInfo(15556)
		ARP_Content1["BossPreview"..n]:SetPosition(-1, -1, 0)
		ARP_Content1["BossPreview"..n]:SetCamera(2)
		ARP_Content1["BossPreview"..n]:SetRotation(0.2)
		ARP_Content1["BossPreview"..n]:SetPortraitZoom(0.1)
		ARP_Content1["BossPreview"..n]:SetCamDistanceScale(1)
		ARP_Content1["BossPreview"..n]:Show()
	end
	
elseif AchchazusRaidplanerDBlocal.AnimationSave ~= true then

		ARP_Content1["DayEventText"..n]:ClearAllPoints();
		ARP_Content1["DayEventText"..n]:SetPoint("CENTER", ARP_Content1["DayFrame"..n], "CENTER", 0, 0);
end

ARP_Content1["DayFrame"..n]:Show()


ARP_Content1["DayText"..n]:SetText(days)
ARP_Content1["DayNummer"..n]:SetText(CountDay)

CountDay = CountDay + 1

end

end

if AchchazusRaidplanerDBlocal.InCalender == false then	  -- ARP_Content 1 - NO Calender

ARP_Content1.DDCheckBox:Show()
ARP_Content1.HealCheckBox:Show()
ARP_Content1.TankCheckBox:Show()
ARP_Content1.AwayCheckBox:Show()
ARP_Content1.Tanktexture:Show()
ARP_Content1.Healtexture:Show()
ARP_Content1.DDtexture:Show()
ARP_Content1.AwayCheckBoxText:SetText(ARP_AWAY)
ARP_Content1.RegistrationButton:Show()
ARP_Content1.BackButton:Show()
ARP_Content[1]["RaidIDCounterForward"]:Show()
ARP_Content[1]["RaidIDCounterBack"]:Show()

if outdatet == true then
	ARP_Content1.OutDatedText:Show()
end


for key, value in pairs(AchchazusRaidplanerDBclass) do 
	ARP_Content1[key]:SetText(AchchazusRaidplanerDBclass[key]["realname"])
end

local CounterRegistration = 0

if outdatet == true then

ARP_Content1.RegistrationButton:Disable()

end

for value in pairs(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page]) do 
	if AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][math.floor(count+1)] ~= nil then
		CounterRegistration = CounterRegistration + 1
	end
end	

AchchazusRaidplanerDBlocal.counterRegistration = CounterRegistration

for key, value in pairs(AchchazusRaidplanerDBclass) do

if AchchazusRaidplanerDBlocal.RegistrationClass == string.upper(AchchazusRaidplanerDBclass[key]["name"]) then	

for i = AchchazusRaidplanerDBlocal.counterRegistration, 1, -1 do
	if AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][i] == AchchazusRaidplanerDBlocal.Anmeldung .. ".f." .. key or AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][i] == AchchazusRaidplanerDBlocal.Anmeldung .. ".t." .. key then 
		RegisteredRaids[1][AchchazusRaidplanerDBlocal.Page] = true
		ARP_Content1.RegistrationButton:SetText(UnregistrationButtonText);
		break 
	end
	if AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][i] ~= AchchazusRaidplanerDBlocal.Anmeldung .. ".f." .. key or AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][i] ~= AchchazusRaidplanerDBlocal.Anmeldung .. ".t." .. key then 
		RegisteredRaids[1][AchchazusRaidplanerDBlocal.Page] = false
		ARP_Content1.RegistrationButton:SetText(RegistrationButtonText); 
	end
end
end
end

for key, value in pairs(AchchazusRaidplanerDBclass) do 
	if key == "cS" then
	ARP_Content1[key]:SetTextColor(AchchazusRaidplanerDBclass[key]["r"], AchchazusRaidplanerDBclass[key]["g"], AchchazusRaidplanerDBclass[key]["b"])
	end
end

count = tonumber(ARP_RaidEntrys())

if AchchazusRaidplanerDBlocal.Page == 1 then
	ARP_Content[1]["RaidIDCounterBack"]:Disable()
else
	ARP_Content[1]["RaidIDCounterBack"]:Enable()
end

if AchchazusRaidplanerDBlocal.Page == count then
	ARP_Content[1]["RaidIDCounterForward"]:Disable()
else
	ARP_Content[1]["RaidIDCounterForward"]:Enable()
end

dd = string.sub(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][2], 1, 2)
mm = string.sub(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][2], 4, 5)
yy = string.sub(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][2], 7, 8)

NummerOfDay, NameOfDay = ARP_GetDayofWeek(dd, mm, yy) 

ARP_Content1.RaidID:SetText(ARP_RAIDID..AchchazusRaidplanerDBlocal.Page)
ARP_Content1.RaidDate:SetText(ARP_RAIDDATE..NameOfDay.." "..AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][2])
ARP_Content1.RaidName:SetText(ARP_RAIDNAME.. AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][1])

count = tonumber(ARP_RaidEntrys())

ARP_Content1.RaidIDCounter:SetText(ARP_RAID..AchchazusRaidplanerDBlocal.Page..ARP_FROM..count)

AchchazusRaidplanerDBlocal.count = 0
local count = 0
for value, key in pairs(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page]) do
	if string.match(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][value], "%.t") or string.match(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][value], "%.f") and not string.match(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][value], "%.cA") then
	count = count + 1
	end
end

AchchazusRaidplanerDBlocal.count = count

ARP_Content1.Registered:SetText(ARP_REGISTERED_PLAYER..AchchazusRaidplanerDBlocal.count )

local count = 0
AchchazusRaidplanerDBlocal.conformt = 0

for value in pairs(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page]) do 
	if string.match(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][value], "%.t") then
		count = count + 1
	end
AchchazusRaidplanerDBlocal.confirmed = count	
end

ARP_Content1.Approved:SetText(ARP_APPROVED_PLAYER..AchchazusRaidplanerDBlocal.confirmed)

CounterRegistration = 0

for value in pairs(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page]) do 
	if AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][math.floor(count+1)] ~= nil then
		CounterRegistration = CounterRegistration + 1
	end
end	

AchchazusRaidplanerDBlocal.counterRegistration = CounterRegistration


for key, value in pairs(AchchazusRaidplanerDBclass) do
local count = 1
	for i = 1, AchchazusRaidplanerDBlocal.counterRegistration, 1 do
		if AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][i] ~= nil then
			if string.match(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][i], key) and string.match(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][i], "%.t" ) then
				length = string.len(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][i])
				ARP_Content1[key..count]:SetText((string.sub(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][i], 1, math.floor(length-5)))) 
				ARP_Content1[key..count]:SetTextColor(AchchazusRaidplanerDBlocal.ApprovedColorR, AchchazusRaidplanerDBlocal.ApprovedColorG, AchchazusRaidplanerDBlocal.ApprovedColorB, AchchazusRaidplanerDBlocal.ApprovedColorA)
				count = count + 1
			elseif string.match(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][i], key) and string.match(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][i], "%.f" )then
				length = string.len(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][i])
				ARP_Content1[key..count]:SetText((string.sub(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][i], 1, math.floor(length-5))))
				ARP_Content1[key..count]:SetTextColor(AchchazusRaidplanerDBclass[key]["r"], AchchazusRaidplanerDBclass[key]["g"], AchchazusRaidplanerDBclass[key]["b"])
				count = count + 1
			end
		end
	end
end


if RegisteredRaids[1][AchchazusRaidplanerDBlocal.Page] == true then
	ARP_Content1.RegistrationButton:SetText(UnregistrationButtonText);
end
if RegisteredRaids[1][AchchazusRaidplanerDBlocal.Page] == false then
	ARP_Content1.RegistrationButton:SetText(RegistrationButtonText)
end

end

do														  -- ARP_ARP_Content 2 and 3

for n = 1, 2 , 1 do
if AchchazusRaidplanerDBlocal.Page == 1 then
	ARP_Content[n]["RaidIDCounterBack"]:Disable()
else
	ARP_Content[n]["RaidIDCounterBack"]:Enable()
end
if AchchazusRaidplanerDBlocal.Page == count then
	ARP_Content[n]["RaidIDCounterForward"]:Disable()
else
	ARP_Content[n]["RaidIDCounterForward"]:Enable()
end
end

for n = 1, 80, 1 do
	if ARP_Content2["Registered"..n]:GetText() ~= "Test" then
		ARP_Content2["Registered"..n]:SetText("Test")
	end
	if ARP_Content2["Confirmed"..n]:GetText() ~= "Test" then
		ARP_Content2["Confirmed"..n]:SetText("Test")
	end
end

for  i = 1, 15, 1 do 
	if AchchazusRaidplanerDB[i] ~= nil and AchchazusRaidplanerDB[i] ~= "Test" then 
		ARP_Content3["RegisteredRaids"..i]:SetText("ID"..i .. ": " .. AchchazusRaidplanerDB[i][1])
		ARP_Content3["RegisteredRaids"..i]:Show()
	end
	if AchchazusRaidplanerDB[i] == "Test" then
		ARP_Content3["RegisteredRaids"..i]:Hide()
	end
end

dd = string.sub(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][2], 1, 2)
mm = string.sub(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][2], 4, 5)
yy = string.sub(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][2], 7, 8)

NummerOfDay, NameOfDay = ARP_GetDayofWeek(dd, mm, yy) 

ARP_Content2.RaidID:SetText(ARP_RAIDID..AchchazusRaidplanerDBlocal.Page)
ARP_Content2.RaidDate:SetText(ARP_RAIDDATE..NameOfDay.." "..AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][2])
ARP_Content2.RaidName:SetText(ARP_RAIDNAME.. AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][1])

count = tonumber(ARP_RaidEntrys())

ARP_Content2.RaidIDCounter:SetText(ARP_RAID..AchchazusRaidplanerDBlocal.Page..ARP_FROM..count)

AchchazusRaidplanerDBlocal.count = 0
local count = 0
for value, key in pairs(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page]) do
	if string.match(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][value], "%.t") or string.match(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][value], "%.f") and not string.match(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][value], "%.cA") then
	count = count + 1
	end
end

AchchazusRaidplanerDBlocal.count = count

ARP_Content2.Registered:SetText(ARP_REGISTERED_PLAYER.. AchchazusRaidplanerDBlocal.count )


local count = 0
AchchazusRaidplanerDBlocal.conformt = 0

for value in pairs(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page]) do 
	if string.match(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][value], "%.t") then
		count = count + 1
	end
AchchazusRaidplanerDBlocal.confirmed = count	
end

ARP_Content2.Approved:SetText(ARP_APPROVED_PLAYER..AchchazusRaidplanerDBlocal.confirmed)

CounterRegistration = 0

for value in pairs(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page]) do 
	if AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][math.floor(count+1)] ~= nil then
		CounterRegistration = CounterRegistration + 1
	end
end	

AchchazusRaidplanerDBlocal.counterRegistration = CounterRegistration


local i = 1

for value, key in pairs(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page]) do 
	if value ~= "" then
		if string.match(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][value], "%.t") and not string.match(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][value], "%.cA") and AchchazusRaidplanerDBlocal.FocusClass == "ALL" then
			ARP_Content2.RegisteredPlayer:SetText(ARP_REGISTERED_PLAYER)
			ARP_Content2.confirmedPlayer:SetText(ARP_APPROVED_PLAYER)
			if ARP_Content2["Confirmed"..i]:GetText() == "Test" then 
				length = string.len(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][value])
				ARP_Content2["Confirmed"..i]:SetText(string.sub(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][value], 1, math.floor(length-5)))
				i = i + 1
				end
			for n = 1, 79, 1 do
			if ARP_Content2["Registered"..n]:GetText() == "Test" then
				if ARP_Content2["Registered"..math.floor(n+1)]:GetText() ~= "Test" then
					ARP_Content2["Registered"..n]:SetText(ARP_Content2["Registered"..math.floor(n+1)]:GetText())
					ARP_Content2["Registered"..math.floor(n+1)]:SetText("Test")
				end
			end
			end
		end
		if string.match(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][value], "%.t") and not string.match(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][value], "%.cA") and string.find(AchchazusRaidplanerDBlocal.FocusClass, string.sub(key, -2)) then
			ARP_Content2.RegisteredPlayer:SetText(ARP_REGISTERED..AchchazusRaidplanerDBclass[AchchazusRaidplanerDBlocal.FocusClass]["realname"]..":")
			ARP_Content2.confirmedPlayer:SetText(ARP_APPROVED..AchchazusRaidplanerDBclass[AchchazusRaidplanerDBlocal.FocusClass]["realname"]..":")
			if ARP_Content2["Confirmed"..i]:GetText() == "Test" then 
				length = string.len(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][value])
				ARP_Content2["Confirmed"..i]:SetText(string.sub(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][value], 1, math.floor(length-5)))
				i = i + 1
				end
			for n = 1, 79, 1 do
			if ARP_Content2["Registered"..n]:GetText() == "Test" then
				if ARP_Content2["Registered"..math.floor(n+1)]:GetText() ~= "Test" then
					ARP_Content2["Registered"..n]:SetText(ARP_Content2["Registered"..math.floor(n+1)]:GetText())
					ARP_Content2["Registered"..math.floor(n+1)]:SetText("Test")
				end
			end
			end
		end
	end
end

local i = 1

for value, key in pairs(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page]) do 
	if value ~= "" then
		if string.match(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][value], "%.f") and not string.match(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][value], "%.cA") and AchchazusRaidplanerDBlocal.FocusClass == "ALL" then
			ARP_Content2.RegisteredPlayer:SetText(ARP_REGISTERED_PLAYER)
			ARP_Content2.confirmedPlayer:SetText(ARP_APPROVED_PLAYER)
			if ARP_Content2["Registered"..i]:GetText() == "Test" then 
				length = string.len(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][value])
				ARP_Content2["Registered"..i]:SetText(string.sub(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][value], 1, math.floor(length-5)))
				i = i + 1
				end
			for n = 1, 79, 1 do
			if ARP_Content2["Confirmed"..n]:GetText() == "Test" then
				if ARP_Content2["Confirmed"..math.floor(n+1)]:GetText() ~= "Test" then
					ARP_Content2["Confirmed"..n]:SetText(ARP_Content2["Confirmed"..math.floor(n+1)]:GetText())
					ARP_Content2["Confirmed"..math.floor(n+1)]:SetText("Test")
				end
			end
			end
		end
		if string.match(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][value], "%.f") and not string.match(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][value], "%.cA") and string.find(AchchazusRaidplanerDBlocal.FocusClass, string.sub(key, -2)) then
			ARP_Content2.RegisteredPlayer:SetText(ARP_REGISTERED..AchchazusRaidplanerDBclass[AchchazusRaidplanerDBlocal.FocusClass]["realname"]..":")
			ARP_Content2.confirmedPlayer:SetText(ARP_APPROVED..AchchazusRaidplanerDBclass[AchchazusRaidplanerDBlocal.FocusClass]["realname"]..":")
			if ARP_Content2["Registered"..i]:GetText() == "Test" then 
				length = string.len(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][value])
				ARP_Content2["Registered"..i]:SetText(string.sub(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][value], 1, math.floor(length-5)))
				i = i + 1
				end
			for n = 1, 79, 1 do
			if ARP_Content2["Confirmed"..n]:GetText() == "Test" then
				if ARP_Content2["Confirmed"..math.floor(n+1)]:GetText() ~= "Test" then
					ARP_Content2["Confirmed"..n]:SetText(ARP_Content2["Confirmed"..math.floor(n+1)]:GetText())
					ARP_Content2["Confirmed"..math.floor(n+1)]:SetText("Test")
				end
			end
			end
		end
		
		
		
	end
end


for i = 1, 80, 1 do
if ARP_Content2["Confirmed"..i]:GetText() == "Test" then 
    ARP_Content2["Confirmed"..i]:Hide()
else
    ARP_Content2["Confirmed"..i]:Show()
end
end

for i = 1, 80, 1 do
if ARP_Content2["Registered"..i]:GetText() == "Test" then 
    ARP_Content2["Registered"..i]:Hide()
else
    ARP_Content2["Registered"..i]:Show()
end
end

local count = 0
for value in pairs(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page]) do 
	if AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][math.floor(count+1)] ~= nil then
		count = count + 1
	end
AchchazusRaidplanerDBlocal.counterRegistration = count
end	

count_totalapproved = 0
count_totalregistered = 0

for key, value in pairs(AchchazusRaidplanerDBclass) do 
if key ~= "cA" then
count_approved = 0
count_registered = 0
ARP_Content2["Approved"..key]:SetText("0")
ARP_Content2["Registered"..key]:SetText("0")
for i = 1 ,AchchazusRaidplanerDBlocal.counterRegistration ,1 do
	if string.match(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][i], key ) and string.match(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][i], "%.t" )then
	count_approved = count_approved + 1
	count_totalapproved = count_totalapproved + 1
	ARP_Content2["Approved"..key]:SetText(count_approved)
	end
	if string.match(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][i], key ) and string.match(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][i], "%.f" )then
	count_registered = count_registered + 1
	count_totalregistered = count_totalregistered + 1
	ARP_Content2["Registered"..key]:SetText(count_registered)
	end
end
end
end

ARP_Content2.totalRegistered:SetText(count_totalregistered)
ARP_Content2.totalApproved:SetText(count_totalapproved)

end

end

ARP_Content1.AwayCheckBox:SetScript("OnClick", function(self)				--Away CheckBox ButtonScript

ARP_PlayShowButtons()

AchchazusRaidplanerDBlocal.Anmeldung = AchchazusRaidplanerDBlocal.playerName

for key, value in pairs(AchchazusRaidplanerDBclass) do 

local count = 0
for value in pairs(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page]) do 
	if AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][math.floor(count+1)] ~= nil then
		count = count + 1
	end

end	

for i = AchchazusRaidplanerDBlocal.counterRegistration, 1, -1 do
	if string.match(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][i], AchchazusRaidplanerDBlocal.Anmeldung) and string.sub(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][i], -2) == "cA" then
		ARP_Content1.AwayCheckBox:SetChecked(true)
	end
	if string.match(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][i], AchchazusRaidplanerDBlocal.Anmeldung) and string.sub(AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][i], -2) ~= "cA" then
		ARP_Content1.AwayCheckBox:SetChecked(false)
	end
	
end
end
end )

ARP_Content1.RegistrationButton:SetScript("OnClick", function()				--Registrations ButtonScript

ARP_PlayShowButtons()

AchchazusRaidplanerDBlocal.RegistrationClass = AchchazusRaidplanerDBlocal.englishClass
AchchazusRaidplanerDBlocal.Anmeldung = AchchazusRaidplanerDBlocal.playerName

for key, value in pairs(AchchazusRaidplanerDBclass) do 

isChecked = ARP_Content1.AwayCheckBox:GetChecked()

if isChecked == true then
AchchazusRaidplanerDBlocal.RegistrationClass = "AWAY"
end

if AchchazusRaidplanerDBlocal.RegistrationClass == string.upper(AchchazusRaidplanerDBclass[key]["name"]) then	

for i = AchchazusRaidplanerDBlocal.counterRegistration, 1, -1 do
	if AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][i] == AchchazusRaidplanerDBlocal.Anmeldung .. ".f." .. key or AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][i] == AchchazusRaidplanerDBlocal.Anmeldung .. ".t." .. key then 
		AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][i] = AchchazusRaidplanerDBlocal.Anmeldung .. ".f." .. key
		AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][i] = nil
		if AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][math.floor(i+1)] ~= nil then
			for m = i, AchchazusRaidplanerDBlocal.counterRegistration, 1 do
				AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][m] = AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][math.floor(m+1)]
				AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][math.floor(m+1)] = nil
			end
		end
		for n = 1, 79, 1 do
		if ARP_Content2["Registered"..n]:GetText() == AchchazusRaidplanerDBlocal.Anmeldung then
			ARP_Content2["Registered"..n]:SetText("Test")
		end
		if ARP_Content2["Confirmed"..n]:GetText() == AchchazusRaidplanerDBlocal.Anmeldung then
			ARP_Content2["Confirmed"..n]:SetText("Test")
		end
		end
		RegisteredRaids[1][AchchazusRaidplanerDBlocal.Page] = false
		ARP_SendMessage()
		ARP_UpdateUI()
		return 
	end
end

for i = 1, math.floor(AchchazusRaidplanerDBlocal.counterRegistration+1), 1 do
	if AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][i] == 0 or AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][i] == nil then 
		AchchazusRaidplanerDB[AchchazusRaidplanerDBlocal.Page][i] = AchchazusRaidplanerDBlocal.Anmeldung .. ".f." .. key
		RegisteredRaids[1][AchchazusRaidplanerDBlocal.Page] = true
		ARP_SendMessage()
		ARP_UpdateUI()
		return
	end
end
end
end
end )

StaticPopupDialogs["CONFORM_DELETE"] = {
  text = ARP_WARNING_DELETE,
  button1 = ARP_YES,
  button2 = ARP_NO,
  OnAccept = function()
      DeleteRaid()
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3, 
}

function ClearAllARP_Content1()

for key, value in pairs(AchchazusRaidplanerDBclass) do 

for i = 1, 25, 1 do
	ARP_Content1[key..i]:SetText("")
end

end

for n = 1 , 40 , 1 do
ARP_Content1["BossPreview"..n]:Hide()
ARP_Content1["DayFrame"..n]:Hide()
ARP_Content1["TodayDayFrame"..n]:Hide()
ARP_Content1.MonthForrward:Hide()
ARP_Content1.MonthBack:Hide()
ARP_Content1["DayText"..n]:SetText("")
ARP_Content1["DayNummer"..n]:SetText("")
ARP_Content1["DayEventText"..n]:SetText("")
ARP_Content1.MonthText:SetText("")
ARP_Content1["DayFrame"..n]:SetBackdropBorderColor(0.4, 0.4, 0.4)
end

ARP_Content[1]["RaidIDCounter"]:SetText("")
ARP_Content[1]["RaidIDCounterForward"]:Hide()
ARP_Content[1]["RaidIDCounterBack"]:Hide()
ARP_Content[1]["RaidID"]:SetText("")
ARP_Content[1]["RaidDate"]:SetText("")
ARP_Content[1]["RaidName"]:SetText("")
ARP_Content[1]["Registered"]:SetText("")
ARP_Content[1]["Approved"]:SetText("")

ARP_Content1.AwayCheckBoxText:SetText("")

ARP_Content1.AwayCheckBox:Hide()
ARP_Content1.RegistrationButton:Hide()
ARP_Content1.BackButton:Hide()
ARP_Content1.DDCheckBox:Hide()
ARP_Content1.HealCheckBox:Hide()
ARP_Content1.TankCheckBox:Hide()
ARP_Content1.Tanktexture:Hide()
ARP_Content1.Healtexture:Hide()
ARP_Content1.DDtexture:Hide()
ARP_Content1.OutDatedText:Hide()
ARP_Content1.ResetText:Hide()

if tonumber(NumbersRaidIDs) ~= 0 then
	for i = 1, tonumber(NumbersRaidIDs), 1 do
		ARP_Content1["ID"..i]:Hide()
	end
end

for key, value in pairs(AchchazusRaidplanerDBclass) do 
	ARP_Content1[key]:SetText("")
end


end

ARP_UpdateUI()

end

EventListener:RegisterEvents(RelevantEvents)
EventListener:SetScript("OnEvent", EventHandler)